/**
 * @license EaselJS
 * Visit https://createjs.com for documentation, updates and examples.
 *
 * Copyright (c) 2017 gskinner.com, inc.
 *
 * Distributed under the terms of the MIT license.
 * http://www.opensource.org/licenses/mit-license.html
 *
 * This notice shall be included in all copies or substantial portions of the Software.
 */
!function(t,i){"use strict";var h=function(){function i(t,e,i){void 0===e&&(e=!1),void 0===i&&(i=!1),this.type=t,this.target=null,this.currentTarget=null,this.eventPhase=0,this.bubbles=e,this.cancelable=i,this.timeStamp=(new Date).getTime(),this.defaultPrevented=!1,this.propagationStopped=!1,this.immediatePropagationStopped=!1,this.removed=!1}var t=i.prototype;return t.preventDefault=function(){return this.defaultPrevented=this.cancelable,this},t.stopPropagation=function(){return this.propagationStopped=!0,this},t.stopImmediatePropagation=function(){return this.immediatePropagationStopped=this.propagationStopped=!0,this},t.remove=function(){return this.removed=!0,this},t.clone=function(){var t=new i(this.type,this.bubbles,this.cancelable);for(var e in this)this.hasOwnProperty(e)&&(t[e]=this[e]);return t},t.set=function(t){for(var e in t)this[e]=t[e];return this},t.toString=function(){return"["+this.constructor.name+" (type="+this.type+")]"},i}(),e=function(){function i(){this._listeners=null,this._captureListeners=null}i.initialize=function(t){var e=i.prototype;t.addEventListener=e.addEventListener,t.on=e.on,t.removeEventListener=t.off=e.removeEventListener,t.removeAllEventListeners=e.removeAllEventListeners,t.hasEventListener=e.hasEventListener,t.dispatchEvent=e.dispatchEvent,t._dispatchEvent=e._dispatchEvent,t.willTrigger=e.willTrigger};var t=i.prototype;return t.addEventListener=function(t,e,i){var n;void 0===i&&(i=!1);var r=(n=i?this._captureListeners=this._captureListeners||{}:this._listeners=this._listeners||{})[t];return r&&(this.removeEventListener(t,e,i),r=n[t]),r?r.push(e):n[t]=[e],e},t.on=function(t,e,i,n,r,s){return void 0===i&&(i=null),void 0===n&&(n=!1),void 0===r&&(r={}),void 0===s&&(s=!1),e.handleEvent&&(i=i||e,e=e.handleEvent),i=i||this,this.addEventListener(t,function(t){e.call(i,t,r),n&&t.remove()},s)},t.removeEventListener=function(t,e,i){void 0===i&&(i=!1);var n=i?this._captureListeners:this._listeners;if(n){var r=n[t];if(r)for(var s=r.length,a=0;a<s;a++)if(r[a]===e){1===s?delete n[t]:r.splice(a,1);break}}},t.off=function(t,e,i){void 0===i&&(i=!1),this.removeEventListener(t,e,i)},t.removeAllEventListeners=function(t){void 0===t&&(t=null),t?(this._listeners&&delete this._listeners[t],this._captureListeners&&delete this._captureListeners[t]):this._listeners=this._captureListeners=null},t.dispatchEvent=function(t,e,i){if(void 0===e&&(e=!1),void 0===i&&(i=!1),"string"==typeof t){var n=this._listeners;if(!(e||n&&n[t]))return!0;t=new h(t,e,i)}else t.target&&t.clone&&(t=t.clone());try{t.target=this}catch(t){}if(t.bubbles&&this.parent){for(var r=this,s=[r];r.parent;)s.push(r=r.parent);var a,o=s.length;for(a=o-1;0<=a&&!t.propagationStopped;a--)s[a]._dispatchEvent(t,1+(0==a));for(a=1;a<o&&!t.propagationStopped;a++)s[a]._dispatchEvent(t,3)}else this._dispatchEvent(t,2);return!t.defaultPrevented},t.hasEventListener=function(t){var e=this._listeners,i=this._captureListeners;return!!(e&&e[t]||i&&i[t])},t.willTrigger=function(t){for(var e=this;e;){if(e.hasEventListener(t))return!0;e=e.parent}return!1},t.toString=function(){return"["+(this.constructor.name+this.name?" "+this.name:"")+"]"},t._dispatchEvent=function(t,e){var i=1===e?this._captureListeners:this._listeners;if(t&&i){var n,r=i[t.type];if(!r||0===(n=r.length))return;try{t.currentTarget=this}catch(t){}try{t.eventPhase=e}catch(t){}t.removed=!1,r=r.slice();for(var s=0;s<n&&!t.immediatePropagationStopped;s++){var a=r[s];a.handleEvent?a.handleEvent(t):a(t),t.removed&&(this.off(t.type,a,1===e),t.removed=!1)}}},i}();function n(t,e){for(var i=0;i<e.length;i++){var n=e[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}function o(t,e,i){return e&&n(t.prototype,e),i&&n(t,i),t}function l(t,e){t.prototype=Object.create(e.prototype),(t.prototype.constructor=t).__proto__=e}function r(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var s=function(n){function i(t){var e;return(e=n.call(this)||this).name=t,e.timingMode=i.TIMEOUT,e.maxDelta=0,e.paused=!1,e._inited=!1,e._startTime=0,e._pausedTime=0,e._ticks=0,e._pausedTicks=0,e._interval=50,e._lastTime=0,e._times=null,e._tickTimes=null,e._timerId=null,e._raf=!0,e}l(i,n),o(i,null,[{key:"RAF_SYNCHED",get:function(){return"synched"}},{key:"RAF",get:function(){return"raf"}},{key:"TIMEOUT",get:function(){return"timeout"}}]);var t=i.prototype;return t.init=function(){this._inited||(this._inited=!0,this._times=[],this._tickTimes=[],this._startTime=this._getTime(),this._times.push(this._lastTime=0),this._setupTick())},t.reset=function(){if(this._raf){var t=window.cancelAnimationFrame||window.webkitCancelAnimationFrame||window.mozCancelAnimationFrame||window.oCancelAnimationFrame||window.msCancelAnimationFrame;t&&t(this._timerId)}else clearTimeout(this._timerId);this.removeAllEventListeners("tick"),this._timerId=this._times=this._tickTimes=null,this._startTime=this._lastTime=this._ticks=0,this._inited=!1},t.addEventListener=function(t,e,i){return!this._inited&&this.init(),n.prototype.addEventListener.call(this,t,e,i)},t.getMeasuredTickTime=function(t){void 0===t&&(t=null);var e=this._tickTimes;return!e||e.length<1?-1:(t=Math.min(e.length,t||0|this.framerate),e.reduce(function(t,e){return t+e},0)/t)},t.getMeasuredFPS=function(t){void 0===t&&(t=null);var e=this._times;return!e||e.length<2?-1:(t=Math.min(e.length-1,t||0|this.framerate),1e3/((e[0]-e[t])/t))},t.getTime=function(t){return void 0===t&&(t=!1),this._startTime?this._getTime()-(t?this._pausedTime:0):-1},t.getEventTime=function(t){return void 0===t&&(t=!1),this._startTime?(this._lastTime||this._startTime)-(t?this._pausedTime:0):-1},t.getTicks=function(t){return void 0===t&&(t=!1),this._ticks-(t?this._pausedTicks:0)},t._handleSynch=function(){this._timerId=null,this._setupTick(),this._getTime()-this._lastTime>=.97*(this._interval-1)&&this._tick()},t._handleRAF=function(){this._timerId=null,this._setupTick(),this._tick()},t._handleTimeout=function(){this._timerId=null,this._setupTick(),this._tick()},t._setupTick=function(){if(null==this._timerId){var t=this.timingMode||this._raf&&i.RAF;if(t===i.RAF_SYNCHED||t===i.RAF){var e=window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.oRequestAnimationFrame||window.msRequestAnimationFrame;if(e)return this._timerId=e(t===i.RAF?this._handleRAF.bind(this):this._handleSynch.bind(this)),void(this._raf=!0)}this._raf=!1,this._timerId=setTimeout(this._handleTimeout.bind(this),this._interval)}},t._tick=function(){var t=this.paused,e=this._getTime(),i=e-this._lastTime;if(this._lastTime=e,this._ticks++,t&&(this._pausedTicks++,this._pausedTime+=i),this.hasEventListener("tick")){var n=new h("tick"),r=this.maxDelta;n.delta=r&&r<i?r:i,n.paused=t,n.time=e,n.runTime=e-this._pausedTime,this.dispatchEvent(n)}for(this._tickTimes.unshift(this._getTime()-e);100<this._tickTimes.length;)this._tickTimes.pop();for(this._times.unshift(e);100<this._times.length;)this._times.pop()},t._getTime=function(){var t=window.performance&&window.performance.now;return(t&&t.call(performance)||(new Date).getTime())-this._startTime},i.on=function(t,e,i,n,r,s){return a.on(t,e,i,n,r,s)},i.removeEventListener=function(t,e,i){a.removeEventListener(t,e,i)},i.off=function(t,e,i){a.off(t,e,i)},i.removeAllEventListeners=function(t){a.removeAllEventListeners(t)},i.dispatchEvent=function(t,e,i){return a.dispatchEvent(t,e,i)},i.hasEventListener=function(t){return a.hasEventListener(t)},i.willTrigger=function(t){return a.willTrigger(t)},i.toString=function(){return a.toString()},i.init=function(){a.init()},i.reset=function(){a.reset()},i.addEventListener=function(t,e,i){a.addEventListener(t,e,i)},i.getMeasuredTickTime=function(t){return a.getMeasuredTickTime(t)},i.getMeasuredFPS=function(t){return a.getMeasuredFPS(t)},i.getTime=function(t){return a.getTime(t)},i.getEventTime=function(t){return a.getEventTime(t)},i.getTicks=function(t){return a.getTicks(t)},o(i,[{key:"interval",get:function(){return this._interval},set:function(t){this._interval=t,this._inited&&this._setupTick()}},{key:"framerate",get:function(){return 1e3/this._interval},set:function(t){this.interval=1e3/t}}],[{key:"interval",get:function(){return a.interval},set:function(t){a.interval=t}},{key:"framerate",get:function(){return a.framerate},set:function(t){a.framerate=t}},{key:"name",get:function(){return a.name},set:function(t){a.name=t}},{key:"timingMode",get:function(){return a.timingMode},set:function(t){a.timingMode=t}},{key:"maxDelta",get:function(){return a.maxDelta},set:function(t){a.maxDelta=t}},{key:"paused",get:function(){return a.paused},set:function(t){a.paused=t}}]),i}(e),a=new s("createjs.global"),u=function(){throw new Error("\n\t\t\tStageGL is not currently supported on the EaselJS 2.0 branch.\n\t\t\tEnd of Q1 2018 is targetted for StageGL support.\n\t\t\tFollow @CreateJS on Twitter for updates.\n\t\t")},c=function(){function t(t,e,i,n){void 0===t&&(t="black"),void 0===e&&(e=0),void 0===i&&(i=0),void 0===n&&(n=0),this.color=t,this.offsetX=e,this.offsetY=i,this.blur=n}var e=t.prototype;return e.toString=function(){return"["+this.constructor.name+"]"},e.clone=function(){return new t(this.color,this.offsetX,this.offsetY,this.blur)},t}();c.identity=new c("transparent");var d=0;function f(){return d++}var p=function(){function t(t,e){this.setValues(t,e)}var e=t.prototype;return e.setValues=function(t,e){return void 0===t&&(t=0),void 0===e&&(e=0),this.x=t,this.y=e,this},e.copy=function(t){return this.x=t.x,this.y=t.y,this},e.clone=function(){return new t(this.x,this.y)},e.toString=function(){return"["+this.constructor.name+" (x="+this.x+" y="+this.y+")]"},t}(),_=function(){function d(t,e,i,n,r,s){this.setValues(t,e,i,n,r,s)}var t=d.prototype;return t.setValues=function(t,e,i,n,r,s){return void 0===t&&(t=1),void 0===e&&(e=0),void 0===i&&(i=0),void 0===n&&(n=1),void 0===r&&(r=0),void 0===s&&(s=0),this.a=t,this.b=e,this.c=i,this.d=n,this.tx=r,this.ty=s,this},t.append=function(t,e,i,n,r,s){var a=this.a,o=this.b,h=this.c,u=this.d;return 1==t&&0==e&&0==i&&1==n||(this.a=a*t+h*e,this.b=o*t+u*e,this.c=a*i+h*n,this.d=o*i+u*n),this.tx=a*r+h*s+this.tx,this.ty=o*r+u*s+this.ty,this},t.prepend=function(t,e,i,n,r,s){var a=this.a,o=this.c,h=this.tx;return this.a=t*a+i*this.b,this.b=e*a+n*this.b,this.c=t*o+i*this.d,this.d=e*o+n*this.d,this.tx=t*h+i*this.ty+r,this.ty=e*h+n*this.ty+s,this},t.appendMatrix=function(t){return this.append(t.a,t.b,t.c,t.d,t.tx,t.ty)},t.prependMatrix=function(t){return this.prepend(t.a,t.b,t.c,t.d,t.tx,t.ty)},t.appendTransform=function(t,e,i,n,r,s,a,o,h){var u,l,c;return c=r%360?(u=r*d.DEG_TO_RAD,l=Math.cos(u),Math.sin(u)):(l=1,0),s||a?(s*=d.DEG_TO_RAD,a*=d.DEG_TO_RAD,this.append(Math.cos(a),Math.sin(a),-Math.sin(s),Math.cos(s),t,e),this.append(l*i,c*i,-c*n,l*n,0,0)):this.append(l*i,c*i,-c*n,l*n,t,e),(o||h)&&(this.tx-=o*this.a+h*this.c,this.ty-=o*this.b+h*this.d),this},t.prependTransform=function(t,e,i,n,r,s,a,o,h){var u,l,c;return c=r%360?(u=r*d.DEG_TO_RAD,l=Math.cos(u),Math.sin(u)):(l=1,0),(o||h)&&(this.tx-=o,this.ty-=h),s||a?(s*=d.DEG_TO_RAD,a*=d.DEG_TO_RAD,this.prepend(l*i,c*i,-c*n,l*n,0,0),this.prepend(Math.cos(a),Math.sin(a),-Math.sin(s),Math.cos(s),t,e)):this.prepend(l*i,c*i,-c*n,l*n,t,e),this},t.rotate=function(t){t*=d.DEG_TO_RAD;var e=Math.cos(t),i=Math.sin(t),n=this.a,r=this.b;return this.a=n*e+this.c*i,this.b=r*e+this.d*i,this.c=-n*i+this.c*e,this.d=-r*i+this.d*e,this},t.skew=function(t,e){return t*=d.DEG_TO_RAD,e*=d.DEG_TO_RAD,this.append(Math.cos(e),Math.sin(e),-Math.sin(t),Math.cos(t),0,0),this},t.scale=function(t,e){return this.a*=t,this.b*=t,this.c*=e,this.d*=e,this},t.translate=function(t,e){return this.tx+=this.a*t+this.c*e,this.ty+=this.b*t+this.d*e,this},t.identity=function(){return this.a=this.d=1,this.b=this.c=this.tx=this.ty=0,this},t.invert=function(){var t=this.a,e=this.b,i=this.c,n=this.d,r=this.tx,s=t*n-e*i;return this.a=n/s,this.b=-e/s,this.c=-i/s,this.d=t/s,this.tx=(i*this.ty-n*r)/s,this.ty=-(t*this.ty-e*r)/s,this},t.isIdentity=function(){return 0===this.tx&&0===this.ty&&1===this.a&&0===this.b&&0===this.c&&1===this.d},t.equals=function(t){return this.tx===t.tx&&this.ty===t.ty&&this.a===t.a&&this.b===t.b&&this.c===t.c&&this.d===t.d},t.transformPoint=function(t,e,i){return void 0===i&&(i=new p),i.x=t*this.a+e*this.c+this.tx,i.y=t*this.b+e*this.d+this.ty,i},t.decompose=function(t){void 0===t&&(t={}),t.x=this.tx,t.y=this.ty,t.scaleX=Math.sqrt(this.a*this.a+this.b*this.b),t.scaleY=Math.sqrt(this.c*this.c+this.d*this.d);var e=Math.atan2(-this.c,this.d),i=Math.atan2(this.b,this.a);return Math.abs(1-e/i)<1e-5?(t.rotation=i/d.DEG_TO_RAD,this.a<0&&0<=this.d&&(t.rotation+=t.rotation<=0?180:-180),t.skewX=t.skewY=0):(t.skewX=e/d.DEG_TO_RAD,t.skewY=i/d.DEG_TO_RAD),t},t.copy=function(t){return this.setValues(t.a,t.b,t.c,t.d,t.tx,t.ty)},t.clone=function(){return new d(this.a,this.b,this.c,this.d,this.tx,this.ty)},t.toString=function(){return"["+this.constructor.name+" (a="+this.a+" b="+this.b+" c="+this.c+" d="+this.d+" tx="+this.tx+" ty="+this.ty+")]"},d}();_.DEG_TO_RAD=Math.PI/180,_.identity=new _;var v=function(){function t(t,e,i,n,r){this.setValues(t,e,i,n,r)}var e=t.prototype;return e.setValues=function(t,e,i,n,r){return void 0===t&&(t=!0),void 0===e&&(e=1),this.visible=t,this.alpha=e,this.shadow=i,this.compositeOperation=n,this.matrix=r||this.matrix&&this.matrix.identity()||new _,this},e.append=function(t,e,i,n,r){return this.alpha*=e,this.shadow=i||this.shadow,this.compositeOperation=n||this.compositeOperation,this.visible=this.visible&&t,r&&this.matrix.appendMatrix(r),this},e.prepend=function(t,e,i,n,r){return this.alpha*=e,this.shadow=this.shadow||i,this.compositeOperation=this.compositeOperation||n,this.visible=this.visible&&t,r&&this.matrix.prependMatrix(r),this},e.identity=function(){return this.visible=!0,this.alpha=1,this.shadow=this.compositeOperation=null,this.matrix.identity(),this},e.clone=function(){return new t(this.alpha,this.shadow,this.compositeOperation,this.visible,this.matrix.clone())},t}(),x=function(){function s(t,e,i,n){this.setValues(t,e,i,n)}var t=s.prototype;return t.setValues=function(t,e,i,n){return void 0===t&&(t=0),void 0===e&&(e=0),void 0===i&&(i=0),void 0===n&&(n=0),this.x=t,this.y=e,this.width=i,this.height=n,this},t.extend=function(t,e,i,n){return void 0===i&&(i=0),void 0===n&&(n=0),t+i>this.x+this.width&&(this.width=t+i-this.x),e+n>this.y+this.height&&(this.height=e+n-this.y),t<this.x&&(this.width+=this.x-t,this.x=t),e<this.y&&(this.height+=this.y-e,this.y=e),this},t.pad=function(t,e,i,n){return this.x-=e,this.y-=t,this.width+=e+n,this.height+=t+i,this},t.copy=function(t){return this.setValues(t.x,t.y,t.width,t.height)},t.contains=function(t,e,i,n){return void 0===i&&(i=0),void 0===n&&(n=0),t>=this.x&&t+i<=this.x+this.width&&e>=this.y&&e+n<=this.y+this.height},t.union=function(t){return this.clone().extend(t.x,t.y,t.width,t.height)},t.intersection=function(t){var e=t.x,i=t.y,n=e+t.width,r=i+t.height;return this.x>e&&(e=this.x),this.y>i&&(i=this.y),this.x+this.width<n&&(n=this.x+this.width),this.y+this.height<r&&(r=this.y+this.height),n<=e||r<=i?null:new s(e,i,n-e,r-i)},t.intersects=function(t){return t.x<=this.x+this.width&&this.x<=t.x+t.width&&t.y<=this.y+this.height&&this.y<=t.y+t.height},t.isEmpty=function(){return this.width<=0||this.height<=0},t.clone=function(){return new s(this.x,this.y,this.width,this.height)},t.toString=function(){return"["+this.constructor.name+" (x="+this.x+" y="+this.y+" width="+this.width+" height="+this.height+")]"},s}(),g=function(){function t(){this.usesContext=!1,this._multiPass=null,this.VTX_SHADER_BODY=null,this.FRAG_SHADER_BODY=null}var e=t.prototype;return e.getBounds=function(t){},e.shaderParamSetup=function(t,e,i){},e.applyFilter=function(t,e,i,n,r,s,a,o){s=s||t,null==a&&(a=e),null==o&&(o=i);try{var h=t.getImageData(e,i,n,r);if(this._applyFilter(h))return s.putImageData(h,a,o),!0}catch(t){}return!1},e.toString=function(){return"["+this.constructor.name+"]"},e.clone=function(){return new t},e._applyFilter=function(t){},t}(),m=function(e){function n(){var t;return(t=e.call(this)||this).width=void 0,t.height=void 0,t.x=void 0,t.y=void 0,t.scale=1,t.offX=0,t.offY=0,t.cacheID=0,t._filterOffX=0,t._filterOffY=0,t._cacheDataURLID=0,t._cacheDataURL=null,t._drawWidth=0,t._drawHeight=0,t._boundRect=new x,t}l(n,e),n.getFilterBounds=function(t,e){void 0===e&&(e=new x);var i=t.filters,n=i&&i.length;if(!!n<=0)return e;for(var r=0;r<n;r++){var s=i[r];if(s&&s.getBounds){var a=s.getBounds();a&&(0==r?e.setValues(a.x,a.y,a.width,a.height):e.extend(a.x,a.y,a.width,a.height))}}return e};var t=n.prototype;return t.define=function(t,e,i,n,r,s,a){if(void 0===e&&(e=0),void 0===i&&(i=0),void 0===n&&(n=1),void 0===r&&(r=1),void 0===s&&(s=1),!t)throw"No symbol to cache";this._options=a,this._useWebGL=void 0!==a,this.target=t,this.width=1<=n?n:1,this.height=1<=r?r:1,this.x=e,this.y=i,this.scale=s,this.update()},t.update=function(t){if(!this.target)throw"define() must be called before update()";var e=n.getFilterBounds(this.target),i=this.target.cacheCanvas;this._drawWidth=Math.ceil(this.width*this.scale)+e.width,this._drawHeight=Math.ceil(this.height*this.scale)+e.height,i&&this._drawWidth==i.width&&this._drawHeight==i.height||this._updateSurface(),this._filterOffX=e.x,this._filterOffY=e.y,this.offX=this.x*this.scale+this._filterOffX,this.offY=this.y*this.scale+this._filterOffY,this._drawToCache(t),this.cacheID=this.cacheID?this.cacheID+1:1},t.release=function(){var t=this.target.stage;this._useWebGL&&this._webGLCache?(this._webGLCache.isCacheControlled||(this.__lastRT&&(this.__lastRT=void 0),this.__rtA&&this._webGLCache._killTextureObject(this.__rtA),this.__rtB&&this._webGLCache._killTextureObject(this.__rtB),this.target&&this.target.cacheCanvas&&this._webGLCache._killTextureObject(this.target.cacheCanvas)),this._webGLCache=!1):t instanceof u&&t.releaseTexture(this.target.cacheCanvas),this.target=this.target.cacheCanvas=null,this.cacheID=this._cacheDataURLID=this._cacheDataURL=void 0,this.width=this.height=this.x=this.y=this.offX=this.offY=0,this.scale=1},t.getCacheDataURL=function(){var t=this.target&&this.target.cacheCanvas;return t?(this.cacheID!=this._cacheDataURLID&&(this._cacheDataURLID=this.cacheID,this._cacheDataURL=t.toDataURL?t.toDataURL():null),this._cacheDataURL):null},t.draw=function(t){return!!this.target&&(t.drawImage(this.target.cacheCanvas,this.x+this._filterOffX/this.scale,this.y+this._filterOffY/this.scale,this._drawWidth/this.scale,this._drawHeight/this.scale),!0)},t.getBounds=function(){var t=this.scale;return this._boundRect.setValue(this._filterOffX/t,this._filterOffY/t,this.width/t,this.height/t)},t._updateSurface=function(){var t;if(!this._useWebGL)return(t=this.target.cacheCanvas)||(t=this.target.cacheCanvas=window.createjs&&createjs.createCanvas?createjs.createCanvas():document.createElement("canvas")),t.width=this._drawWidth,void(t.height=this._drawHeight);if(!this._webGLCache)if("stage"===this._options.useGL){if(null==this.target.stage||!this.target.stage.isWebGL)throw"Cannot use 'stage' for cache because the object's parent stage is "+(null!=this.target.stage?"non WebGL.":"not set, please addChild to the correct stage.");this.target.cacheCanvas=!0,this._webGLCache=this.target.stage}else{if("new"!==this._options.useGL)throw"Invalid option provided to useGL, expected ['stage', 'new', StageGL, undefined], got "+this._options.useGL;this.target.cacheCanvas=document.createElement("canvas"),this._webGLCache=new u(this.target.cacheCanvas,{antialias:!0,transparent:!0,autoPurge:-1}),this._webGLCache.isCacheControlled=!0}var e=this._webGLCache;t=this.target.cacheCanvas,e.isCacheControlled&&(t.width=this._drawWidth,t.height=this._drawHeight,e.updateViewport(this._drawWidth,this._drawHeight)),this.target.filters?(e.getTargetRenderTexture(this.target,this._drawWidth,this._drawHeight),e.getTargetRenderTexture(this.target,this._drawWidth,this._drawHeight)):e.isCacheControlled||e.getTargetRenderTexture(this.target,this._drawWidth,this._drawHeight)},t._drawToCache=function(t){var e=this.target,i=e.cacheCanvas,n=this._webGLCache;if(!this._useWebGL||!n){var r=i.getContext("2d");return t||r.clearRect(0,0,this._drawWidth+1,this._drawHeight+1),r.save(),r.globalCompositeOperation=t,r.setTransform(this.scale,0,0,this.scale,-this._filterOffX,-this._filterOffY),r.translate(-this.x,-this.y),e.draw(r,!0),r.restore(),e.filters&&e.filters.length&&this._applyFilters(e),void(i._invalid=!0)}this._webGLCache.cacheDraw(e,e.filters,this),(i=this.target.cacheCanvas).width=this._drawWidth,i.height=this._drawHeight,i._invalid=!0},t._applyFilters=function(){for(var t=this.target.cacheCanvas,e=this.target.filters,i=this._drawWidth,n=this._drawHeight,r=t.getContext("2d").getImageData(0,0,i,n),s=e.length,a=0;a<s;a++)e[a]._applyFilter(r);t.getContext("2d").putImageData(r,0,0)},n}(g),w=function(e){function a(){var t;return(t=e.call(this)||this).alpha=1,t.cacheCanvas=null,t.bitmapCache=null,t.id=f(),t.mouseEnabled=!0,t.tickEnabled=!0,t.name=null,t.parent=null,t.regX=0,t.regY=0,t.rotation=0,t.scaleX=1,t.scaleY=1,t.skewX=0,t.skewY=0,t.shadow=null,t.visible=!0,t.x=0,t.y=0,t.transformMatrix=null,t.compositeOperation=null,t.snapToPixel=!0,t.filters=null,t.mask=null,t.hitArea=null,t.cursor=null,t._props=new v,t._rectangle=new x,t._bounds=null,t._webGLRenderStyle=a._StageGL_NONE,t}l(a,e);var t=a.prototype;return t.isVisible=function(){return!!(this.visible&&0<this.alpha&&0!=this.scaleX&&0!=this.scaleY)},t.draw=function(t,e){return void 0===e&&(e=!1),this.drawCache(t,e)},t.drawCache=function(t,e){void 0===e&&(e=!1);var i=this.bitmapCache;return!(!i||e)&&i.draw(t)},t.updateContext=function(t){var e=this,i=e.mask,n=e._props.matrix;i&&i.graphics&&!i.graphics.isEmpty()&&(i.getMatrix(n),t.transform(n.a,n.b,n.c,n.d,n.tx,n.ty),i.graphics.drawAsPath(t),t.clip(),n.invert(),t.transform(n.a,n.b,n.c,n.d,n.tx,n.ty)),this.getMatrix(n);var r=n.tx,s=n.ty;a._snapToPixelEnabled&&e.snapToPixel&&(r=r+(r<0?-.5:.5)|0,s=s+(s<0?-.5:.5)|0),t.transform(n.a,n.b,n.c,n.d,r,s),t.globalAlpha*=e.alpha,e.compositeOperation&&(t.globalCompositeOperation=e.compositeOperation),e.shadow&&this._applyShadow(t,e.shadow)},t.cache=function(t,e,i,n,r,s){void 0===r&&(r=1),this.bitmapCache||(this.bitmapCache=new m),this.bitmapCache.define(this,t,e,i,n,r,s)},t.updateCache=function(t){if(!this.bitmapCache)throw"No cache found. cache() must be called before updateCache()";this.bitmapCache.update(t)},t.uncache=function(){this.bitmapCache&&(this.bitmapCache.release(),this.bitmapCache=void 0)},t.getCacheDataURL=function(){return this.bitmapCache?this.bitmapCache.getDataURL():null},t.localToGlobal=function(t,e,i){return void 0===i&&(i=new p),this.getConcatenatedMatrix(this._props.matrix).transformPoint(t,e,i)},t.globalToLocal=function(t,e,i){return void 0===i&&(i=new p),this.getConcatenatedMatrix(this._props.matrix).invert().transformPoint(t,e,i)},t.localToLocal=function(t,e,i,n){return n=this.localToGlobal(t,e,n),i.globalToLocal(n.x,n.y,n)},t.setTransform=function(t,e,i,n,r,s,a,o,h){return void 0===t&&(t=0),void 0===e&&(e=0),void 0===i&&(i=1),void 0===n&&(n=1),void 0===r&&(r=0),void 0===s&&(s=0),void 0===a&&(a=0),void 0===o&&(o=0),void 0===h&&(h=0),this.x=t,this.y=e,this.scaleX=i,this.scaleY=n,this.rotation=r,this.skewX=s,this.skewY=a,this.regX=o,this.regY=h,this},t.getMatrix=function(t){var e=this,i=t&&t.identity()||new _;return e.transformMatrix?i.copy(e.transformMatrix):i.appendTransform(e.x,e.y,e.scaleX,e.scaleY,e.rotation,e.skewX,e.skewY,e.regX,e.regY)},t.getConcatenatedMatrix=function(t){for(var e=this,i=this.getMatrix(t);e=e.parent;)i.prependMatrix(e.getMatrix(e._props.matrix));return i},t.getConcatenatedDisplayProps=function(t){t=t?t.identity():new v;for(var e=this,i=e.getMatrix(t.matrix);t.prepend(e.visible,e.alpha,e.shadow,e.compositeOperation),e!=this&&i.prependMatrix(e.getMatrix(e._props.matrix)),e=e.parent;);return t},t.hitTest=function(t,e){var i=a._hitTestContext;i.setTransform(1,0,0,1,-t,-e),this.draw(i);var n=this._testHit(i);return i.setTransform(1,0,0,1,0,0),i.clearRect(0,0,2,2),n},t.set=function(t){for(var e in t)this[e]=t[e];return this},t.getBounds=function(){if(this._bounds)return this._rectangle.copy(this._bounds);var t=this.cacheCanvas;if(t){var e=this._cacheScale;return this._rectangle.setValues(this._cacheOffsetX,this._cacheOffsetY,t.width/e,t.height/e)}return null},t.getTransformedBounds=function(){return this._getBounds()},t.setBounds=function(t,e,i,n){null==t&&(this._bounds=null),this._bounds=(this._bounds||new x).setValues(t,e,i,n)},t.clone=function(){return this._cloneProps(new a)},t.toString=function(){return"["+this.constructor.name+(this.name?" (name="+this.name+")":"")+"]"},t._cloneProps=function(t){return t.alpha=this.alpha,t.mouseEnabled=this.mouseEnabled,t.tickEnabled=this.tickEnabled,t.name=this.name,t.regX=this.regX,t.regY=this.regY,t.rotation=this.rotation,t.scaleX=this.scaleX,t.scaleY=this.scaleY,t.shadow=this.shadow,t.skewX=this.skewX,t.skewY=this.skewY,t.visible=this.visible,t.x=this.x,t.y=this.y,t.compositeOperation=this.compositeOperation,t.snapToPixel=this.snapToPixel,t.filters=null==this.filters?null:this.filters.slice(0),t.mask=this.mask,t.hitArea=this.hitArea,t.cursor=this.cursor,t._bounds=this._bounds,t},t._applyShadow=function(t,e){void 0===e&&(e=c.identity),e=e,t.shadowColor=e.color,t.shadowOffsetX=e.offsetX,t.shadowOffsetY=e.offsetY,t.shadowBlur=e.blur},t._tick=function(t){var e=this._listeners;e&&e.tick&&(t.target=null,t.propagationStopped=t.immediatePropagationStopped=!1,this.dispatchEvent(t))},t._testHit=function(t){try{return 1<t.getImageData(0,0,1,1).data[3]}catch(t){if(!a.suppressCrossDomainErrors)throw"An error has occurred. This is most likely due to security restrictions on reading canvas pixel data with local or cross-domain images.";return!1}},t._getBounds=function(t,e){return this._transformBounds(this.getBounds(),t,e)},t._transformBounds=function(t,e,i){if(!t)return t;var n=t.x,r=t.y,s=t.width,a=t.height,o=this._props.matrix;o=i?o.identity():this.getMatrix(o),(n||r)&&o.appendTransform(0,0,1,1,0,0,0,-n,-r),e&&o.prependMatrix(e);var h=s*o.a,u=s*o.b,l=a*o.c,c=a*o.d,d=o.tx,f=o.ty,p=d,_=d,v=f,g=f;return(n=h+d)<p?p=n:_<n&&(_=n),(n=h+l+d)<p?p=n:_<n&&(_=n),(n=l+d)<p?p=n:_<n&&(_=n),(r=u+f)<v?v=r:g<r&&(g=r),(r=u+c+f)<v?v=r:g<r&&(g=r),(r=c+f)<v?v=r:g<r&&(g=r),t.setValues(p,v,_-p,g-v)},t._hasMouseEventListener=function(){for(var t=a._MOUSE_EVENTS,e=0,i=t.length;e<i;e++)if(this.hasEventListener(t[e]))return!0;return!!this.cursor},o(a,[{key:"stage",get:function(){for(var t=this;t.parent;)t=t.parent;return/^\[Stage(GL)?(\s\(name=\w+\))?\]$/.test(t.toString())?t:null}},{key:"scale",set:function(t){this.scaleX=this.scaleY=t},get:function(){return this.scaleX}}]),a}(e),y=window.createjs&&createjs.createCanvas?createjs.createCanvas():document.createElement("canvas");y.getContext&&(w._hitTestCanvas=y,w._hitTestContext=y.getContext("2d"),y.width=y.height=1),w._MOUSE_EVENTS=["click","dblclick","mousedown","mouseout","mouseover","pressmove","pressup","rollout","rollover"],w.suppressCrossDomainErrors=!1,w.snapToPixelEnabled=!1,w._StageGL_NONE=0,w._StageGL_SPRITE=1,w._StageGL_BITMAP=2;var b=function(h){function p(){var t;return(t=h.call(this)||this).children=[],t.mouseChildren=!0,t.tickChildren=!0,t}l(p,h);var t=p.prototype;return t.isVisible=function(){var t=this.cacheCanvas||this.children.length;return!!(this.visible&&0<this.alpha&&0!=this.scaleX&&0!=this.scaleY&&t)},t.draw=function(t,e){if(void 0===e&&(e=!1),h.prototype.draw.call(this,t,e))return!0;for(var i=this.children.slice(),n=0,r=i.length;n<r;n++){var s=i[n];s.isVisible()&&(t.save(),s.updateContext(t),s.draw(t),t.restore())}return!0},t.addChild=function(){var t=arguments.length;if(0===t)return null;var e=arguments.length<=0?void 0:arguments[0];if(1<t){for(var i=0;i<t;i++)e=this.addChild(i<0||arguments.length<=i?void 0:arguments[i]);return e}var n=e.parent,r=n===this;return n&&n._removeChildAt(n.children.indexOf(e),r),(e.parent=this).children.push(e),r||e.dispatchEvent("added"),e},t.addChildAt=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];var n=e.length;if(0===n)return null;var r=e.pop();if(r<0||r>this.children.length)return e[n-2];if(2<n){for(var s=0;s<n-1;s++)this.addChildAt(e[s],r++);return e[n-2]}var a=e[0],o=a.parent,h=o===this;return o&&o._removeChildAt(o.children.indexOf(a),h),(a.parent=this).children.splice(r++,0,a),h||a.dispatchEvent("added"),a},t.removeChild=function(){var t=arguments.length;if(0===t)return!0;if(1<t){for(var e=!0,i=0;i<t;i++)e=e&&this.removeChild(i<0||arguments.length<=i?void 0:arguments[i]);return e}return this._removeChildAt(this.children.indexOf(arguments.length<=0?void 0:arguments[0]))},t.removeChildAt=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];var n=e.length;if(0===n)return!0;if(1<n){e.sort(function(t,e){return e-t});for(var r=!0,s=0;s<n;s++)r=r&&this._removeChildAt(e[s]);return r}return this._removeChildAt(e[0])},t.removeAllChildren=function(){for(var t=this.children;t.length;)this._removeChildAt(0)},t.getChildAt=function(t){return this.children[t]},t.getChildByName=function(t){for(var e=this.children,i=e.length,n=0;n<i;n++)if(e[n].name===t)return e[n];return null},t.sortChildren=function(t){this.children.sort(t)},t.getChildIndex=function(t){return this.children.indexOf(t)},t.swapChildrenAt=function(t,e){var i=this.children,n=i[t],r=i[e];n&&r&&(i[t]=r,i[e]=n)},t.swapChildren=function(t,e){for(var i,n,r=this.children,s=r.length,a=0;a<s&&(r[a]===t&&(i=a),r[a]===e&&(n=a),null==i||null==n);a++);a!==s&&(r[i]=e,r[n]=t)},t.setChildIndex=function(t,e){var i=this.children,n=i.length;if(!(t.parent!=this||e<0||n<=e)){for(var r=0;r<n&&i[r]!==t;r++);r!==n&&r!==e&&(i.splice(r,1),i.splice(e,0,t))}},t.contains=function(t){for(;t;){if(t===this)return!0;t=t.parent}return!1},t.hitTest=function(t,e){return null!=this.getObjectUnderPoint(t,e)},t.getObjectsUnderPoint=function(t,e,i){void 0===i&&(i=0);var n=[],r=this.localToGlobal(t,e);return this._getObjectsUnderPoint(r.x,r.y,n,0<i,1===i),n},t.getObjectUnderPoint=function(t,e,i){void 0===i&&(i=0);var n=this.localToGlobal(t,e);return this._getObjectsUnderPoint(n.x,n.y,null,0<i,1===i)},t.getBounds=function(){return this._getBounds(null,!0)},t.getTransformedBounds=function(){return this._getBounds()},t.clone=function(t){void 0===t&&(t=!1);var e=this._cloneProps(new p);return t&&this._cloneChildren(e),e},t._tick=function(t){if(this.tickChildren)for(var e=this.children.length-1;0<=e;e--){var i=this.children[e];i.tickEnabled&&i._tick&&i._tick(t)}h.prototype._tick.call(this,t)},t._cloneChildren=function(t){t.children.length&&t.removeAllChildren();for(var e=t.children,i=this.children.length,n=0;n<i;n++){var r=this.children[n].clone(!0);r.parent=t,e.push(r)}},t._removeChildAt=function(t,e){if(void 0===e&&(e=!1),t<0||t>this.children.length-1)return!1;var i=this.children[t];return i&&(i.parent=null),this.children.splice(t,1),e||i.dispatchEvent("removed"),!0},t._getObjectsUnderPoint=function(t,e,i,n,r,s){if(void 0===s&&(s=0),!s&&!this._testMask(this,t,e))return null;var a,o=w._hitTestContext;r=r||n&&this._hasMouseEventListener();for(var h=this.children,u=h.length-1;0<=u;u--){var l=h[u],c=l.hitArea;if(l.visible&&(c||l.isVisible())&&(!n||l.mouseEnabled)&&(c||this._testMask(l,t,e)))if(!c&&l instanceof p){var d=l._getObjectsUnderPoint(t,e,i,n,r,s+1);if(!i&&d)return n&&!this.mouseChildren?this:d}else{if(n&&!r&&!l._hasMouseEventListener())continue;var f=l.getConcatenatedDisplayProps(l._props);if(a=f.matrix,c&&(a.appendMatrix(c.getMatrix(c._props.matrix)),f.alpha=c.alpha),o.globalAlpha=f.alpha,o.setTransform(a.a,a.b,a.c,a.d,a.tx-t,a.ty-e),(c||l).draw(o),!this._testHit(o))continue;if(o.setTransform(1,0,0,1,0,0),o.clearRect(0,0,2,2),!i)return n&&!this.mouseChildren?this:l;i.push(l)}}return null},t._testMask=function(t,e,i){var n=t.mask;if(!n||!n.graphics||n.graphics.isEmpty())return!0;var r=this._props.matrix,s=t.parent;r=s?s.getConcatenatedMatrix(r):r.identity(),r=n.getMatrix(n._props.matrix).prependMatrix(r);var a=w._hitTestContext;return a.setTransform(r.a,r.b,r.c,r.d,r.tx-e,r.ty-i),n.graphics.drawAsPath(a),a.fillStyle="#000",a.fill(),!!this._testHit(a)&&(a.setTransform(1,0,0,1,0,0),a.clearRect(0,0,2,2),!0)},t._getBounds=function(t,e){var i=h.prototype.getBounds.call(this);if(i)return this._transformBounds(i,t,e);var n=this._props.matrix;n=e?n.identity():this.getMatrix(n),t&&n.prependMatrix(t);for(var r=this.children.length,s=null,a=0;a<r;a++){var o=this.children[a];o.visible&&(i=o._getBounds(n))&&(s?s.extend(i.x,i.y,i.width,i.height):s=i.clone())}return s},o(p,[{key:"numChildren",get:function(){return this.children.length}}]),p}(w),T=function(d){function t(t,e,i,n,r,s,a,o,h,u,l){var c;return(c=d.call(this,t,e,i)||this).stageX=n,c.stageY=r,c.rawX=null==h?n:h,c.rawY=null==u?r:u,c.nativeEvent=s,c.pointerID=a,c.primary=!!o,c.relatedTarget=l,c}l(t,d);var e=t.prototype;return e.clone=function(){return new t(this.type,this.bubbles,this.cancelable,this.stageX,this.stageY,this.nativeEvent,this.pointerID,this.primary,this.rawX,this.rawY)},e.toString=function(){return"["+this.constructor.name+" (type="+this.type+" stageX="+this.stageX+" stageY="+this.stageY+")]"},o(t,[{key:"localX",get:function(){return this.currentTarget.globalToLocal(this.rawX,this.rawY).x}},{key:"localY",get:function(){return this.currentTarget.globalToLocal(this.rawX,this.rawY).y}},{key:"isTouch",get:function(){return-1!==this.pointerID}}]),t}(h),E=function(i){function t(t){var e;return(e=i.call(this)||this).autoClear=!0,e.canvas="string"==typeof t?document.getElementById(t):t,e.mouseX=0,e.mouseY=0,e.drawRect=null,e.snapToPixelEnabled=!1,e.mouseInBounds=!1,e.tickOnUpdate=!0,e.mouseMoveOutside=!1,e.preventSelection=!0,e._pointerData={},e._pointerCount=0,e._primaryPointerID=null,e._mouseOverIntervalID=null,e._nextStage=null,e._prevStage=null,e.enableDOMEvents(!0),e}l(t,i);var e=t.prototype;return e.update=function(t){if(this.canvas&&(this.tickOnUpdate&&this.tick(t),!1!==this.dispatchEvent("drawstart",!1,!0))){w._snapToPixelEnabled=this.snapToPixelEnabled;var e=this.drawRect,i=this.canvas.getContext("2d");i.setTransform(1,0,0,1,0,0),this.autoClear&&(e?i.clearRect(e.x,e.y,e.width,e.height):i.clearRect(0,0,this.canvas.width+1,this.canvas.height+1)),i.save(),this.drawRect&&(i.beginPath(),i.rect(e.x,e.y,e.width,e.height),i.clip()),this.updateContext(i),this.draw(i,!1),i.restore(),this.dispatchEvent("drawend")}},e.tick=function(t){if(this.tickEnabled&&!1!==this.dispatchEvent("tickstart",!1,!0)){var e=new h("tick");if(t)for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);this._tick(e),this.dispatchEvent("tickend")}},e.handleEvent=function(t){"tick"===t.type&&this.update(t)},e.clear=function(){if(this.canvas){var t=this.canvas.getContext("2d");t.setTransform(1,0,0,1,0,0),t.clearRect(0,0,this.canvas.width+1,this.canvas.height+1)}},e.toDataURL=function(t,e){void 0===e&&(e="image/png");var i,n=this.canvas.getContext("2d"),r=this.canvas.width,s=this.canvas.height;if(t){i=n.getImageData(0,0,r,s);var a=n.globalCompositeOperation;n.globalCompositeOperation="destination-over",n.fillStyle=t,n.fillRect(0,0,r,s)}var o=this.canvas.toDataURL(e);return t&&(n.putImageData(i,0,0),n.globalCompositeOperation=a),o},e.enableMouseOver=function(t){var e=this;void 0===t&&(t=20),this._mouseOverIntervalID&&(clearInterval(this._mouseOverIntervalID),this._mouseOverIntervalID=null,0===t&&this._testMouseOver(!0)),t<=0||(this._mouseOverIntervalID=setInterval(function(){return e._testMouseOver()},1e3/Math.min(50,t)))},e.enableDOMEvents=function(t){var e=this;void 0===t&&(t=!0);var i=this._eventListeners;if(!t&&i){for(var n in i){var r=i[n];r.t.removeEventListener(n,r.f,!1)}this._eventListeners=null}else if(t&&!i&&this.canvas){var s=window.addEventListener?window:document;for(var a in i=this._eventListeners={mouseup:{t:s,f:function(t){return e._handleMouseUp(t)}},mousemove:{t:s,f:function(t){return e._handleMouseMove(t)}},dblclick:{t:this.canvas,f:function(t){return e._handleDoubleClick(t)}},mousedown:{t:this.canvas,f:function(t){return e._handleMouseDown(t)}}}){var o=i[a];o.t.addEventListener&&o.t.addEventListener(a,o.f,!1)}}},e.clone=function(){throw"Stage cannot be cloned."},e._getElementRect=function(e){var i;try{i=e.getBoundingClientRect()}catch(t){i={top:e.offsetTop,left:e.offsetLeft,width:e.offsetWidth,height:e.offsetHeight}}var t=(window.pageXOffset||document.scrollLeft||0)-(document.clientLeft||document.body.clientLeft||0),n=(window.pageYOffset||document.scrollTop||0)-(document.clientTop||document.body.clientTop||0),r=window.getComputedStyle?getComputedStyle(e,null):e.currentStyle,s=parseInt(r.paddingLeft)+parseInt(r.borderLeftWidth),a=parseInt(r.paddingTop)+parseInt(r.borderTopWidth),o=parseInt(r.paddingRight)+parseInt(r.borderRightWidth),h=parseInt(r.paddingBottom)+parseInt(r.borderBottomWidth);return{left:i.left+t+s,right:i.right+t-o,top:i.top+n+a,bottom:i.bottom+n-h}},e._getPointerData=function(t){var e=this._pointerData[t];return e||(e=this._pointerData[t]={x:0,y:0}),e},e._handleMouseMove=function(t){void 0===t&&(t=window.event),this._handlePointerMove(-1,t,t.pageX,t.pageY)},e._handlePointerMove=function(t,e,i,n,r){if((!this._prevStage||void 0!==r)&&this.canvas){var s=this._nextStage,a=this._getPointerData(t),o=a.inBounds;this._updatePointerPosition(t,e,i,n),(o||a.inBounds||this.mouseMoveOutside)&&(-1===t&&a.inBounds===!o&&this._dispatchMouseEvent(this,o?"mouseleave":"mouseenter",!1,t,a,e),this._dispatchMouseEvent(this,"stagemousemove",!1,t,a,e),this._dispatchMouseEvent(a.target,"pressmove",!0,t,a,e)),s&&s._handlePointerMove(t,e,i,n,null)}},e._updatePointerPosition=function(t,e,i,n){var r=this._getElementRect(this.canvas);i-=r.left,n-=r.top;var s=this.canvas.width,a=this.canvas.height;i/=(r.right-r.left)/s,n/=(r.bottom-r.top)/a;var o=this._getPointerData(t);(o.inBounds=0<=i&&0<=n&&i<=s-1&&n<=a-1)?(o.x=i,o.y=n):this.mouseMoveOutside&&(o.x=i<0?0:s-1<i?s-1:i,o.y=n<0?0:a-1<n?a-1:n),o.posEvtObj=e,o.rawX=i,o.rawY=n,t!==this._primaryPointerID&&-1!==t||(this.mouseX=o.x,this.mouseY=o.y,this.mouseInBounds=o.inBounds)},e._handleMouseUp=function(t){this._handlePointerUp(-1,t,!1)},e._handlePointerUp=function(t,e,i,n){var r=this._nextStage,s=this._getPointerData(t);if(!this._prevStage||void 0!==n){var a=null,o=s.target;n||!o&&!r||(a=this._getObjectsUnderPoint(s.x,s.y,null,!0)),s.down&&(this._dispatchMouseEvent(this,"stagemouseup",!1,t,s,e,a),s.down=!1),a===o&&this._dispatchMouseEvent(o,"click",!0,t,s,e),this._dispatchMouseEvent(o,"pressup",!0,t,s,e),i?(t==this._primaryPointerID&&(this._primaryPointerID=null),delete this._pointerData[t]):s.target=null,r&&r._handlePointerUp(t,e,i,n||a&&this)}},e._handleMouseDown=function(t){this._handlePointerDown(-1,t,t.pageX,t.pageY)},e._handlePointerDown=function(t,e,i,n,r){this.preventSelection&&e.preventDefault(),null!=this._primaryPointerID&&-1!==t||(this._primaryPointerID=t),null!=n&&this._updatePointerPosition(t,e,i,n);var s=null,a=this._nextStage,o=this._getPointerData(t);r||(s=o.target=this._getObjectsUnderPoint(o.x,o.y,null,!0)),o.inBounds&&(this._dispatchMouseEvent(this,"stagemousedown",!1,t,o,e,s),o.down=!0),this._dispatchMouseEvent(s,"mousedown",!0,t,o,e),a&&a._handlePointerDown(t,e,i,n,r||s&&this)},e._testMouseOver=function(t,e,i){if(!this._prevStage||void 0!==e){var n=this._nextStage;if(this._mouseOverIntervalID){var r=this._getPointerData(-1);if(r&&(t||this.mouseX!==this._mouseOverX||this.mouseY!==this._mouseOverY||!this.mouseInBounds)){var s=r.posEvtObj,a=i||s&&s.target===this.canvas,o=null,h=-1,u="";!e&&(t||this.mouseInBounds&&a)&&(o=this._getObjectsUnderPoint(this.mouseX,this.mouseY,null,!0),this._mouseOverX=this.mouseX,this._mouseOverY=this.mouseY);for(var l=this._mouseOverTarget||[],c=l[l.length-1],d=this._mouseOverTarget=[],f=o;f;)d.unshift(f),u||(u=f.cursor),f=f.parent;this.canvas.style.cursor=u,!e&&i&&(i.canvas.style.cursor=u);for(var p=0,_=d.length;p<_&&d[p]==l[p];p++)h=p;c!=o&&this._dispatchMouseEvent(c,"mouseout",!0,-1,r,s,o);for(var v=l.length-1;h<v;v--)this._dispatchMouseEvent(l[v],"rollout",!1,-1,r,s,o);for(var g=d.length-1;h<g;g--)this._dispatchMouseEvent(d[g],"rollover",!1,-1,r,s,c);c!=o&&this._dispatchMouseEvent(o,"mouseover",!0,-1,r,s,c),n&&n._testMouseOver(t,e||o&&this,i||a&&this)}}else n&&n._testMouseOver(t,e,i)}},e._handleDoubleClick=function(t,e){var i=null,n=this._nextStage,r=this._getPointerData(-1);e||(i=this._getObjectsUnderPoint(r.x,r.y,null,!0),this._dispatchMouseEvent(i,"dblclick",!0,-1,r,t)),n&&n._handleDoubleClick(t,e||i&&this)},e._dispatchMouseEvent=function(t,e,i,n,r,s,a){if(t&&(i||t.hasEventListener(e))){var o=new T(e,i,!1,r.x,r.y,s,n,n===this._primaryPointerID||-1===n,r.rawX,r.rawY,a);t.dispatchEvent(o)}},o(t,[{key:"nextStage",get:function(){return this._nextStage},set:function(t){this._nextStage&&(this._nextStage._prevStage=null),t&&(t._prevStage=this),this._nextStage=t}}]),t}(b);function S(t,e){var i;if(void 0===t&&(t=1),void 0===e&&(e=1),void 0!==window.createjs&&void 0!==window.createjs.createCanvas&&(i=window.createjs.createCanvas()),void 0!==window.document&&void 0!==window.document.createElement&&(i=document.createElement("canvas")),void 0!==i)return i.width=t,i.height=e,i;throw"Canvas not supported in this environment."}var C=function(){function t(t){this.readyState=t.readyState,this._video=t,this._canvas=null,this._lastTime=-1,this.readyState<2&&t.addEventListener("canplaythrough",this._videoReady.bind(this))}var e=t.prototype;return e.getImage=function(){if(!(this.readyState<2)){var t=this._canvas,e=this._video;if(t||((t=this._canvas=S()).width=e.videoWidth,t.height=e.videoHeight),2<=e.readyState&&e.currentTime!==this._lastTime){var i=t.getContext("2d");i.clearRect(0,0,t.width,t.height),i.drawImage(e,0,0,t.width,t.height),this._lastTime=e.currentTime}return t}},e._videoReady=function(){this.readyState=2},t}(),M=function(d){function n(t){var e;return e=d.call(this)||this,"string"==typeof t?(e.image=document.createElement("img"),e.image.src=t):e.image=t,e.sourceRect=null,e._webGLRenderStyle=w._StageGL_BITMAP,e}l(n,d);var t=n.prototype;return t.isVisible=function(){var t=this.image,e=this.cacheCanvas||t&&(t.naturalWidth||t.getContext||2<=t.readyState);return!!(this.visible&&0<this.alpha&&0!=this.scaleX&&0!=this.scaleY&&e)},t.draw=function(t,e){if(void 0===e&&(e=!1),d.prototype.draw.call(this,t,e))return!0;var i=this.image,n=this.sourceRect;if(i instanceof C&&(i=i.getImage()),null==i)return!0;if(n){var r=n.x,s=n.y,a=r+n.width,o=s+n.height,h=0,u=0,l=i.width,c=i.height;r<0&&(h-=r,r=0),l<a&&(a=l),s<0&&(u-=s,s=0),c<o&&(o=c),t.drawImage(i,r,s,a-r,o-s,h,u,a-r,o-s)}else t.drawImage(i,0,0);return!0},t.getBounds=function(){var t=d.prototype.getBounds.call(this);if(t)return t;var e=this.image,i=this.sourceRect||e;return e&&(e.naturalWidth||e.getContext||2<=e.readyState)?this._rectangle.setValues(0,0,i.width,i.height):null},t.clone=function(t){var e=this.image;null!=e&&null!=t&&(e=e.cloneNode());var i=new n(e);return this.sourceRect&&(i.sourceRect=this.sourceRect.clone()),this._cloneProps(i),i},n}(w),k=function(r){function t(t,e){var i;return(i=r.call(this)||this).currentFrame=0,i.currentAnimation=null,i.paused=!0,i.spriteSheet=t,i.currentAnimationFrame=0,i.framerate=0,i._animation=null,i._currentFrame=null,i._skipAdvance=!1,i._webGLRenderStyle=w._StageGL_SPRITE,null!=e&&i.gotoAndPlay(e),i}l(t,r);var e=t.prototype;return e.isVisible=function(){var t=this.cacheCanvas||this.spriteSheet.complete;return!!(this.visible&&0<this.alpha&&0!=this.scaleX&&0!=this.scaleY&&t)},e.draw=function(t,e){if(r.prototype.draw.call(this,t,e))return!0;this._normalizeFrame();var i=this.spriteSheet.getFrame(0|this._currentFrame);if(!i)return!1;var n=i.rect;return n.width&&n.height&&t.drawImage(i.image,n.x,n.y,n.width,n.height,-i.regX,-i.regY,n.width,n.height),!0},e.play=function(){this.paused=!1},e.stop=function(){this.paused=!0},e.gotoAndPlay=function(t){this.paused=!1,this._skipAdvance=!0,this._goto(t)},e.gotoAndStop=function(t){this.paused=!0,this._goto(t)},e.advance=function(t){var e=this.framerate||this.spriteSheet.framerate,i=e&&null!=t?t/(1e3/e):1;this._normalizeFrame(i)},e.getBounds=function(){return r.prototype.getBounds.call(this)||this.spriteSheet.getFrameBounds(this.currentFrame,this._rectangle)},e.clone=function(){return this._cloneProps(new t(this.spriteSheet))},e._cloneProps=function(t){return r.prototype._cloneProps.call(this,t),t.currentFrame=this.currentFrame,t.currentAnimation=this.currentAnimation,t.paused=this.paused,t.currentAnimationFrame=this.currentAnimationFrame,t.framerate=this.framerate,t._animation=this._animation,t._currentFrame=this._currentFrame,t._skipAdvance=this._skipAdvance,t},e._tick=function(t){this.paused||(this._skipAdvance||this.advance(t&&t.delta),this._skipAdvance=!1),r.prototype._tick.call(this,t)},e._normalizeFrame=function(t){void 0===t&&(t=0);var e=this._animation,i=this.paused,n=this._currentFrame;if(e){var r=e.speed||1,s=this.currentAnimationFrame,a=e.frames.length;if(a<=s+t*r){var o=e.next;if(this._dispatchAnimationEnd(e,n,i,o,a-1))return;if(o)return this._goto(o,t-(a-s)/r);this.paused=!0,s=e.frames.length-1}else s+=t*r;this.currentAnimationFrame=s,this._currentFrame=e.frames[0|s]}else{n=this._currentFrame+=t;var h=this.spriteSheet.getNumFrames();if(h<=n&&0<h&&!this._dispatchAnimationEnd(e,n,i,h-1)&&(this._currentFrame-=h)>=h)return this._normalizeFrame()}n=0|this._currentFrame,this.currentFrame!=n&&(this.currentFrame=n,this.dispatchEvent("change"))},e._dispatchAnimationEnd=function(t,e,i,n,r){var s=t?t.name:null;if(this.hasEventListener("animationend")){var a=new h("animationend");a.name=s,a.next=n,this.dispatchEvent(a)}var o=this._animation!=t||this._currentFrame!=e;return o||i||!this.paused||(this.currentAnimationFrame=r,o=!0),o},e._goto=function(t,e){if(void 0===e&&(e=0),this.currentAnimationFrame=0,isNaN(t)){var i=this.spriteSheet.getAnimation(t);i&&(this._animation=i,this.currentAnimation=t,this._normalizeFrame(e))}else this.currentAnimation=this._animation=null,this._currentFrame=t,this._normalizeFrame()},t}(w),D=function(n){function m(t,e){var i;return void 0===t&&(t=""),void 0===e&&(e=null),(i=n.call(this)||this).text=t,i.spriteSheet=e,i.lineHeight=0,i.letterSpacing=0,i.spaceWidth=0,i._oldProps={text:0,spriteSheet:0,lineHeight:0,letterSpacing:0,spaceWidth:0},i._oldStage=null,i._drawAction=null,i}l(m,n);var t=m.prototype;return t.draw=function(t,e){this.drawCache(t,e)||(this._updateState(),n.prototype.draw.call(this,t,e))},t.getBounds=function(){return this._updateText(),n.prototype.getBounds.call(this)},t.isVisible=function(){var t=this.cacheCanvas||this.spriteSheet&&this.spriteSheet.complete&&this.text;return!!(this.visible&&0<this.alpha&&0!==this.scaleX&&0!==this.scaleY&&t)},t.clone=function(){return this._cloneProps(new m(this.text,this.spriteSheet))},t.addChild=function(){},t.addChildAt=function(){},t.removeChild=function(){},t.removeChildAt=function(){},t.removeAllChildren=function(){},t._updateState=function(){this._updateText()},t._cloneProps=function(t){return n.prototype._cloneProps.call(this,t),t.lineHeight=this.lineHeight,t.letterSpacing=this.letterSpacing,t.spaceWidth=this.spaceWidth,t},t._getFrameIndex=function(t,e){var i,n=e.getAnimation(t);return n||(t!=(i=t.toUpperCase())||t!=(i=t.toLowerCase())||(i=null),i&&(n=e.getAnimation(i))),n&&n.frames[0]},t._getFrame=function(t,e){var i=this._getFrameIndex(t,e);return null==i?i:e.getFrame(i)},t._getLineHeight=function(t){var e=this._getFrame("1",t)||this._getFrame("T",t)||this._getFrame("L",t)||t.getFrame(0);return e?e.rect.height:1},t._getSpaceWidth=function(t){var e=this._getFrame("1",t)||this._getFrame("l",t)||this._getFrame("e",t)||this._getFrame("a",t)||t.getFrame(0);return e?e.rect.width:1},t._tick=function(t){var e=this.stage;e&&e.on("drawstart",this._updateText,this,!0),n.prototype._tick.call(this,t)},t._updateText=function(){var t,e=0,i=0,n=this._oldProps,r=!1,s=this.spaceWidth,a=this.lineHeight,o=this.spriteSheet,h=m._spritePool,u=this.children,l=0,c=u.length;for(var d in n)n[d]!=this[d]&&(n[d]=this[d],r=!0);if(r){var f=!!this._getFrame(" ",o);f||s||(s=this._getSpaceWidth(o)),a||(a=this._getLineHeight(o));for(var p=0,_=this.text.length;p<_;p++){var v=this.text.charAt(p);if(" "!==v||f)if("\n"!==v&&"\r"!==v){var g=this._getFrameIndex(v,o);null!=g&&(l<c?t=u[l]:(u.push(t=h.length?h.pop():new k),t.parent=this,c++),t.spriteSheet=o,t.gotoAndStop(g),t.x=e,t.y=i,l++,e+=t.getBounds().width+this.letterSpacing)}else"\r"===v&&"\n"===this.text.charAt(p+1)&&p++,e=0,i+=a;else e+=s}for(;l<c;)h.push(t=u.pop()),t.parent=null,c--;h.length>m.maxPoolSize&&(h.length=m.maxPoolSize)}},m}(b);D.maxPoolSize=100,D._spritePool=[];var L=function(n){function t(t){var e;e=n.call(this)||this,"string"==typeof t&&(t=document.getElementById(t)),e.mouseEnabled=!1;var i=t.style;return i.position="absolute",i.transformOrigin=i.WebkitTransformOrigin=i.msTransformOrigin=i.MozTransformOrigin=i.OTransformOrigin="0% 0%",e.htmlElement=t,e._oldProps=null,e._oldStage=null,e._drawAction=null,e}l(t,n);var e=t.prototype;return e.isVisible=function(){return null!=this.htmlElement},e.draw=function(t,e){return!0},e.cache=function(){},e.uncache=function(){},e.updateCache=function(){},e.hitTest=function(){},e.localToGlobal=function(){},e.globalToLocal=function(){},e.localToLocal=function(){},e.clone=function(){throw"DOMElement cannot be cloned."},e._tick=function(t){var e=this.stage;null!=e&&e!==this._oldStage&&(this._drawAction&&e.off("drawend",this._drawAction),this._drawAction=e.on("drawend",this._handleDrawEnd,this),this._oldStage=e),n.prototype._tick.call(this,t)},e._handleDrawEnd=function(t){var e=this.htmlElement;if(e){var i=e.style,n=this.getConcatenatedDisplayProps(this._props),r=n.matrix,s=n.visible?"visible":"hidden";if(s!=i.visibility&&(i.visibility=s),n.visible){var a=this._oldProps,o=a&&a.matrix,h=1e4;if(!o||!o.equals(r)){var u="matrix("+(r.a*h|0)/h+","+(r.b*h|0)/h+","+(r.c*h|0)/h+","+(r.d*h|0)/h+","+(r.tx+.5|0);i.transform=i.WebkitTransform=i.OTransform=i.msTransform=u+","+(r.ty+.5|0)+")",i.MozTransform=u+"px,"+(r.ty+.5|0)+"px)",a||(a=this._oldProps=new v(!0,null)),a.matrix.copy(r)}a.alpha!=n.alpha&&(i.opacity=""+(n.alpha*h|0)/h,a.alpha=n.alpha)}}},t}(w),A=function(){function g(){this.command=null,this._stroke=null,this._strokeStyle=null,this._oldStrokeStyle=null,this._strokeDash=null,this._oldStrokeDash=null,this._fill=null,this._strokeIgnoreScale=!1,this._commitIndex=0,this._instructions=[],this._activeInstructions=[],this._dirty=!1,this._storeIndex=0,this.curveTo=this.quadraticCurveTo,this.drawRect=this.rect,this.mt=this.moveTo,this.lt=this.lineTo,this.at=this.arcTo,this.bt=this.bezierCurveTo,this.qt=this.quadraticCurveTo,this.a=this.arc,this.r=this.rect,this.cp=this.closePath,this.c=this.clear,this.f=this.beginFill,this.lf=this.beginLinearGradientFill,this.rf=this.beginRadialGradientFill,this.bf=this.beginBitmapFill,this.ef=this.endFill,this.ss=this.setStrokeStyle,this.sd=this.setStrokeDash,this.s=this.beginStroke,this.ls=this.beginLinearGradientStroke,this.rs=this.beginRadialGradientStroke,this.bs=this.beginBitmapStroke,this.es=this.endStroke,this.dr=this.drawRect,this.rr=this.drawRoundRect,this.rc=this.drawRoundRectComplex,this.dc=this.drawCircle,this.de=this.drawEllipse,this.dp=this.drawPolyStar,this.p=this.decodePath,this.clear()}g.getRGB=function(t,e,i,n){return null!=t&&null==i&&(n=e,i=255&t,e=t>>8&255,t=t>>16&255),null==n?"rgb("+t+","+e+","+i+")":"rgba("+t+","+e+","+i+","+n+")"},g.getHSL=function(t,e,i,n){return null==n?"hsl("+t%360+","+e+"%,"+i+"%)":"hsl("+t%360+","+e+"%,"+i+"%,"+n+")"};var t=g.prototype;return t.isEmpty=function(){return!(this._instructions.length||this._activeInstructions.length)},t.draw=function(t,e){this._updateInstructions();for(var i=this._instructions,n=i.length,r=this._storeIndex;r<n;r++)i[r].exec(t,e)},t.drawAsPath=function(t){this._updateInstructions();for(var e,i=this._instructions,n=i.length,r=this._storeIndex;r<n;r++)!1!==(e=i[r]).path&&e.exec(t)},t.moveTo=function(t,e){return this.append(new P(t,e),!0)},t.lineTo=function(t,e){return this.append(new I(t,e))},t.arcTo=function(t,e,i,n,r){return this.append(new R(t,e,i,n,r))},t.arc=function(t,e,i,n,r,s){return this.append(new O(t,e,i,n,r,s))},t.quadraticCurveTo=function(t,e,i,n){return this.append(new F(t,e,i,n))},t.bezierCurveTo=function(t,e,i,n,r,s){return this.append(new B(t,e,i,n,r,s))},t.rect=function(t,e,i,n){return this.append(new X(t,e,i,n))},t.closePath=function(){return this._activeInstructions.length?this.append(new N):this},t.clear=function(){return this._instructions.length=this._activeInstructions.length=this._commitIndex=0,this._strokeStyle=this._oldStrokeStyle=this._stroke=this._fill=this._strokeDash=this._oldStrokeDash=null,this._dirty=this._strokeIgnoreScale=!1,this},t.beginFill=function(t){return this._setFill(t?new G(t):null)},t.beginLinearGradientFill=function(t,e,i,n,r,s){return this._setFill((new G).linearGradient(t,e,i,n,r,s))},t.beginRadialGradientFill=function(t,e,i,n,r,s,a,o){return this._setFill((new G).radialGradient(t,e,i,n,r,s,a,o))},t.beginBitmapFill=function(t,e,i){return this._setFill(new G(null,i).bitmap(t,e))},t.endFill=function(){return this.beginFill()},t.setStrokeStyle=function(t,e,i,n,r){return void 0===e&&(e=0),void 0===i&&(i=0),void 0===n&&(n=10),void 0===r&&(r=!1),this._updateInstructions(!0),this._strokeStyle=this.command=new U(t,e,i,n,r),this._stroke&&(this._stroke.ignoreScale=r),this._strokeIgnoreScale=r,this},t.setStrokeDash=function(t,e){return void 0===e&&(e=0),this._updateInstructions(!0),this._strokeDash=this.command=new W(t,e),this},t.beginStroke=function(t){return this._setStroke(t?new H(t):null)},t.beginLinearGradientStroke=function(t,e,i,n,r,s){return this._setStroke((new H).linearGradient(t,e,i,n,r,s))},t.beginRadialGradientStroke=function(t,e,i,n,r,s,a,o){return this._setStroke((new H).radialGradient(t,e,i,n,r,s,a,o))},t.beginBitmapStroke=function(t,e){return void 0===e&&(e="repeat"),this._setStroke((new H).bitmap(t,e))},t.endStroke=function(){return this.beginStroke()},t.drawRoundRect=function(t,e,i,n,r){return this.drawRoundRectComplex(t,e,i,n,r,r,r,r)},t.drawRoundRectComplex=function(t,e,i,n,r,s,a,o){return this.append(new j(t,e,i,n,r,s,a,o))},t.drawCircle=function(t,e,i){return this.append(new V(t,e,i))},t.drawEllipse=function(t,e,i,n){return this.append(new z(t,e,i,n))},t.drawPolyStar=function(t,e,i,n,r,s){return this.append(new q(t,e,i,n,r,s))},t.append=function(t,e){return this._activeInstructions.push(t),this.command=t,e||(this._dirty=!0),this},t.decodePath=function(t){for(var e=[this.moveTo,this.lineTo,this.quadraticCurveTo,this.bezierCurveTo,this.closePath],i=[2,2,4,6,0],n=0,r=t.length,s=[],a=0,o=0,h=g._BASE_64;n<r;){var u=h[t.charAt(n)],l=u>>3,c=e[l];if(!c||3&u)throw"Bad path data (@"+n+"):c";var d=i[l];l||(a=o=0),n++;for(var f=2+(u>>2&1),p=s.length=0;p<d;p++){var _=h[t.charAt(n)],v=_>>5?-1:1;_=(31&_)<<6|h[t.charAt(n+1)],3===f&&(_=_<<6|h[t.charAt(n+2)]),_=v*_/10,p%2?a=_+=a:o=_+=o,s[p]=_,n+=f}c.apply(this,s)}return this},t.store=function(){return this._updateInstructions(!0),this._storeIndex=this._instructions.length,this},t.unstore=function(){return this._storeIndex=0,this},t.clone=function(){var t=new g;return t.command=this.command,t._stroke=this._stroke,t._strokeStyle=this._strokeStyle,t._strokeDash=this._strokeDash,t._strokeIgnoreScale=this._strokeIgnoreScale,t._fill=this._fill,t._instructions=this._instructions.slice(),t._commitIndex=this._commitIndex,t._activeInstructions=this._activeInstructions.slice(),t._dirty=this._dirty,t._storeIndex=this._storeIndex,t},t.toString=function(){return"["+this.constructor.name+"]"},t._updateInstructions=function(t){var e=this._instructions,i=this._activeInstructions,n=this._commitIndex;if(this._dirty&&i.length){e.length=n,e.push(g.beginCmd);var r=i.length,s=e.length;e.length=s+r;for(var a=0;a<r;a++)e[a+s]=i[a];this._fill&&e.push(this._fill),this._stroke&&(this._strokeDash!==this._oldStrokeDash&&e.push(this._strokeDash),this._strokeStyle!==this._oldStrokeStyle&&e.push(this._strokeStyle),t&&(this._oldStrokeDash=this._strokeDash,this._oldStrokeStyle=this._strokeStyle),e.push(this._stroke)),this._dirty=!1}t&&(i.length=0,this._commitIndex=e.length)},t._setFill=function(t){return this._updateInstructions(!0),this.command=this._fill=t,this},t._setStroke=function(t){return this._updateInstructions(!0),(this.command=this._stroke=t)&&(t.ignoreScale=this._strokeIgnoreScale),this},o(g,[{key:"instructions",get:function(){return this._updateInstructions(),this._instructions}}],[{key:"LineTo",get:function(){return I}},{key:"MoveTo",get:function(){return P}},{key:"ArcTo",get:function(){return R}},{key:"Arc",get:function(){return O}},{key:"QuadraticCurveTo",get:function(){return F}},{key:"BezierCurveTo",get:function(){return B}},{key:"Rect",get:function(){return X}},{key:"ClosePath",get:function(){return N}},{key:"BeginPath",get:function(){return Y}},{key:"Fill",get:function(){return G}},{key:"Stroke",get:function(){return H}},{key:"StrokeStyle",get:function(){return U}},{key:"StrokeDash",get:function(){return W}},{key:"RoundRect",get:function(){return j}},{key:"Circle",get:function(){return V}},{key:"Ellipse",get:function(){return z}},{key:"PolyStar",get:function(){return q}}]),g}(),I=function(){function t(t,e){this.x=t,this.y=e}return t.prototype.exec=function(t){t.lineTo(this.x,this.y)},t}(),P=function(){function t(t,e){this.x=t,this.y=e}return t.prototype.exec=function(t){t.moveTo(this.x,this.y)},t}(),R=function(){function t(t,e,i,n,r){this.x1=t,this.y1=e,this.x2=i,this.y2=n,this.radius=r}return t.prototype.exec=function(t){t.arcTo(this.x1,this.y1,this.x2,this.y2,this.radius)},t}(),O=function(){function t(t,e,i,n,r,s){void 0===s&&(s=!1),this.x=t,this.y=e,this.radius=i,this.startAngle=n,this.endAngle=r,this.anticlockwise=s}return t.prototype.exec=function(t){t.arc(this.x,this.y,this.radius,this.startAngle,this.endAngle,this.anticlockwise)},t}(),F=function(){function t(t,e,i,n){this.cpx=t,this.cpy=e,this.x=i,this.y=n}return t.prototype.exec=function(t){t.quadraticCurveTo(this.cpx,this.cpy,this.x,this.y)},t}(),B=function(){function t(t,e,i,n,r,s){this.cp1x=t,this.cp1y=e,this.cp2x=i,this.cp2y=n,this.x=r,this.y=s}return t.prototype.exec=function(t){t.bezierCurveTo(this.cp1x,this.cp1y,this.cp2x,this.cp2y,this.x,this.y)},t}(),X=function(){function t(t,e,i,n){this.x=t,this.y=e,this.w=i,this.h=n}return t.prototype.exec=function(t){t.rect(this.x,this.y,this.w,this.h)},t}(),N=function(){function t(){}return t.prototype.exec=function(t){t.closePath()},t}(),Y=function(){function t(){}return t.prototype.exec=function(t){t.beginPath()},t}(),G=function(){function t(t,e){this.style=t,this.matrix=e,this.path=!1}var e=t.prototype;return e.exec=function(t){if(this.style){t.fillStyle=this.style;var e=this.matrix;e&&(t.save(),t.transform(e.a,e.b,e.c,e.d,e.tx,e.ty)),t.fill(),e&&t.restore()}},e.linearGradient=function(t,e,i,n,r,s){for(var a=this.style=A._ctx.createLinearGradient(i,n,r,s),o=t.length,h=0;h<o;h++)a.addColorStop(e[h],t[h]);return a.props={colors:t,ratios:e,x0:i,y0:n,x1:r,y1:s,type:"linear"},this},e.radialGradient=function(t,e,i,n,r,s,a,o){for(var h=this.style=A._ctx.createRadialGradient(i,n,r,s,a,o),u=t.length,l=0;l<u;l++)h.addColorStop(e[l],t[l]);return h.props={colors:t,ratios:e,x0:i,y0:n,r0:r,x1:s,y1:a,r1:o,type:"radial"},this},e.bitmap=function(t,e){(void 0===e&&(e=""),t.naturalWidth||t.getContext||2<=t.readyState)&&((this.style=A._ctx.createPattern(t,e)).props={image:t,repetition:e,type:"bitmap"});return this},t}(),H=function(n){function t(t,e){var i;return(i=n.call(this)||this).style=t,i.ignoreScale=e,i.path=!1,i}return l(t,n),t.prototype.exec=function(t){this.style&&(t.strokeStyle=this.style,this.ignoreScale&&(t.save(),t.setTransform(1,0,0,1,0,0)),t.stroke(),this.ignoreScale&&t.restore())},t}(G),U=function(){function t(t,e,i,n,r){void 0===t&&(t=1),void 0===e&&(e="butt"),void 0===i&&(i="miter"),void 0===n&&(n=10),void 0===r&&(r=!1),this.width=t,this.caps=e,this.joints=i,this.miterLimit=n,this.ignoreScale=r,this.path=!1}return t.prototype.exec=function(t){t.lineWidth=this.width,t.lineCap=isNaN(this.caps)?this.caps:A._STROKE_CAPS_MAP[this.caps],t.lineJoin=isNaN(this.joints)?this.joints:A._STROKE_JOINTS_MAP[this.joints],t.miterLimit=this.miterLimit,t.ignoreScale=this.ignoreScale},t}(),W=function(){function t(t,e){void 0===t&&(t=[]),void 0===e&&(e=0),this.segments=t,this.offset=e}return t.prototype.exec=function(t){t.setLineDash&&(t.setLineDash(this.segments),t.lineDashOffset=this.offset)},t}(),j=function(){function t(t,e,i,n,r,s,a,o){this.x=t,this.y=e,this.w=i,this.h=n,this.radiusTL=r,this.radiusTR=s,this.radiusBR=a,this.radiusBL=o}return t.prototype.exec=function(t){var e=(this.w<this.h?this.w:this.h)/2,i=0,n=0,r=0,s=0,a=this.x,o=this.y,h=this.w,u=this.h,l=this.radiusTL,c=this.radiusTR,d=this.radiusBR,f=this.radiusBL;l<0&&(l*=i=-1),e<l&&(l=e),c<0&&(c*=n=-1),e<c&&(c=e),d<0&&(d*=r=-1),e<d&&(d=e),f<0&&(f*=s=-1),e<f&&(f=e),t.moveTo(a+h-c,o),t.arcTo(a+h+c*n,o-c*n,a+h,o+c,c),t.lineTo(a+h,o+u-d),t.arcTo(a+h+d*r,o+u+d*r,a+h-d,o+u,d),t.lineTo(a+f,o+u),t.arcTo(a-f*s,o+u+f*s,a,o+u-f,f),t.lineTo(a,o+l),t.arcTo(a-l*i,o-l*i,a+l,o,l),t.closePath()},t}(),V=function(){function t(t,e,i){this.x=t,this.y=e,this.radius=i}return t.prototype.exec=function(t){t.arc(this.x,this.y,this.radius,0,2*Math.PI)},t}(),z=function(){function t(t,e,i,n){this.x=t,this.y=e,this.w=i,this.h=n}return t.prototype.exec=function(t){var e=this.x,i=this.y,n=this.w,r=this.h,s=n/2*.5522848,a=r/2*.5522848,o=e+n,h=i+r,u=e+n/2,l=i+r/2;t.moveTo(e,l),t.bezierCurveTo(e,l-a,u-s,i,u,i),t.bezierCurveTo(u+s,i,o,l-a,o,l),t.bezierCurveTo(o,l+a,u+s,h,u,h),t.bezierCurveTo(u-s,h,e,l+a,e,l)},t}(),q=function(){function t(t,e,i,n,r,s){void 0===r&&(r=0),void 0===s&&(s=0),this.x=t,this.y=e,this.radius=i,this.sides=n,this.pointSize=r,this.angle=s}return t.prototype.exec=function(t){var e=this.x,i=this.y,n=this.radius,r=this.angle/180*Math.PI,s=this.sides,a=1-this.pointSize,o=Math.PI/s;t.moveTo(e+Math.cos(r)*n,i+Math.sin(r)*n);for(var h=0;h<s;h++)r+=o,1!=a&&t.lineTo(e+Math.cos(r)*n*a,i+Math.sin(r)*n*a),r+=o,t.lineTo(e+Math.cos(r)*n,i+Math.sin(r)*n);t.closePath()},t}();A.beginCmd=new Y,A._BASE_64={A:0,B:1,C:2,D:3,E:4,F:5,G:6,H:7,I:8,J:9,K:10,L:11,M:12,N:13,O:14,P:15,Q:16,R:17,S:18,T:19,U:20,V:21,W:22,X:23,Y:24,Z:25,a:26,b:27,c:28,d:29,e:30,f:31,g:32,h:33,i:34,j:35,k:36,l:37,m:38,n:39,o:40,p:41,q:42,r:43,s:44,t:45,u:46,v:47,w:48,x:49,y:50,z:51,0:52,1:53,2:54,3:55,4:56,5:57,6:58,7:59,8:60,9:61,"+":62,"/":63},A._STROKE_CAPS_MAP=["butt","round","square"],A._STROKE_JOINTS_MAP=["miter","round","bevel"],A._ctx=S().getContext("2d");var J=function(n){function s(t){var e;return e=n.call(this)||this,!s.inited&&s.init(),e.mode=null!=t.mode?t.mode:s.INDEPENDENT,e.startPosition=null!=t.startPosition?t.startPosition:0,"number"==typeof t.loop?e.loop=t.loop:!1===t.loop?e.loop=0:e.loop=-1,e.currentFrame=0,e.timeline=new i.Timeline(Object.assign({useTicks:!0,paused:!0},t)),e.paused=null!=t.paused&&t.paused,e.actionsEnabled=!0,e.autoReset=!0,e.frameBounds=e.frameBounds||t.frameBounds,e.framerate=null,e._synchOffset=0,e._rawPosition=-1,e._t=0,e._managed={},e._bound_resolveState=e._resolveState.bind(r(r(e))),e}l(s,n),s.init=function(){s.inited||(Q.install(),s.inited=!0)};var t=s.prototype;return t.isVisible=function(){return!!(this.visible&&0<this.alpha&&0!=this.scaleX&&0!=this.scaleY)},t.draw=function(t,e){return this.drawCache(t,e)||(this._updateState(),n.prototype.draw.call(this,t,e)),!0},t.play=function(){this.paused=!1},t.stop=function(){this.paused=!0},t.gotoAndPlay=function(t){this.play(),this._goto(t)},t.gotoAndStop=function(t){this.stop(),this._goto(t)},t.advance=function(t){if(this.mode===s.INDEPENDENT){for(var e=this,i=e.framerate;(e=e.parent)&&null===i;)e.mode===s.INDEPENDENT&&(i=e._framerate);if(this._framerate=i,!this.paused){var n=null!==i&&-1!==i&&null!==t?t/(1e3/i)+this._t:1,r=0|n;for(this._t=n-r;r--;)this._updateTimeline(this._rawPosition+1,!1)}}},t.clone=function(){throw"MovieClip cannot be cloned."},t._updateState=function(){-1!==this._rawPosition&&this.mode===s.INDEPENDENT||this._updateTimeline(-1)},t._tick=function(t){this.advance(t&&t.delta),n.prototype._tick.call(this,t)},t._goto=function(t){var e=this.timeline.resolve(t);null!=e&&(this._t=0,this._updateTimeline(e,!0))},t._reset=function(){this._rawPosition=-1,this._t=this.currentFrame=0,this.paused=!1},t._updateTimeline=function(t,e){var i=this.mode!==s.INDEPENDENT,n=this.timeline;i&&(t=this.startPosition+(this.mode===s.SINGLE_FRAME?0:this._synchOffset)),t<1&&(t=0),(this._rawPosition!==t||i)&&(this._rawPosition=t,n.loop=this.loop,n.setPosition(t,i||!this.actionsEnabled,e,this._bound_resolveState))},t._renderFirstFrame=function(){var t=this.timeline,e=t.rawPosition;t.setPosition(0,!0,!0,this._bound_resolveState),t.rawPosition=e},t._resolveState=function(){var t=this.timeline;for(var e in this.currentFrame=t.position,this._managed)this._managed[e]=1;var i=t.tweens,n=Array.isArray(i),r=0;for(i=n?i:i[Symbol.iterator]();;){var s;if(n){if(r>=i.length)break;s=i[r++]}else{if((r=i.next()).done)break;s=r.value}var a=s,o=a.target;if(o!==this&&!a.passive){var h=a._stepPosition;o instanceof w?this._addManagedChild(o,h):this._setState(o.state,h)}}for(var u=this.children,l=u.length-1;0<=l;l--){var c=u[l].id;1===this._managed[c]&&(this.removeChildAt(l),delete this._managed[c])}},t._setState=function(t,e){if(t)for(var i=t.length-1;0<=i;i--){var n=t[i],r=n.t,s=n.p;for(var a in s)r[a]=s[a];this._addManagedChild(r,e)}},t._addManagedChild=function(t,e){t._off||(this.addChildAt(t,0),t instanceof s&&(t._synchOffset=e,t.mode===s.INDEPENDENT&&t.autoReset&&!this._managed[t.id]&&t._reset()),this._managed[t.id]=2)},t._getBounds=function(t,e){var i=this.getBounds();return!i&&this.frameBounds&&(i=this._rectangle.copy(this.frameBounds[this.currentFrame])),i?this._transformBounds(i,t,e):n.prototype._getBounds.call(this,t,e)},o(s,[{key:"labels",get:function(){return this.timeline.labels}},{key:"currentLabel",get:function(){return this.timeline.currentLabel}},{key:"duration",get:function(){return this.timeline.duration}},{key:"totalFrames",get:function(){return this.duration}}]),s}(b);J.INDEPENDENT="independent",J.SINGLE_FRAME="single",J.SYNCHED="synched",J.inited=!1;var Q=function(){function t(){throw"MovieClipPlugin cannot be instantiated."}return t.install=function(){i.Tween.installPlugin(t)},t.init=function(t,e,i){return i},t.tween=function(t,e,i,n,r,s,a,o){return t.target instanceof J?1===s?r[e]:n[e]:i},t}();Q.priority=100;var K=function(i){function n(t){var e;return void 0===t&&(t=new A),(e=i.call(this)||this).graphics=t,e}l(n,i);var t=n.prototype;return t.isVisible=function(){var t=this.cacheCanvas||this.graphics&&!this.graphics.isEmpty();return!!(this.visible&&0<this.alpha&&0!=this.scaleX&&0!=this.scaleY&&t)},t.draw=function(t,e){return void 0===e&&(e=!1),i.prototype.draw.call(this,t,e)||this.graphics.draw(t,this),!0},t.clone=function(t){void 0===t&&(t=!1);var e=t&&this.graphics?this.graphics.clone():this.graphics;return this._cloneProps(new n(e))},n}(w),Z=function(i){function t(t){var e;return(e=i.call(this)||this).complete=!0,e.framerate=0,e._animations=null,e._frames=null,e._images=null,e._data=null,e._loadCount=0,e._frameHeight=0,e._frameWidth=0,e._numFrames=0,e._regX=0,e._regY=0,e._spacing=0,e._margin=0,e._parseData(t),e}l(t,i);var e=t.prototype;return e.getNumFrames=function(t){if(null==t)return this._frames?this._frames.length:this._numFrames||0;var e=this._data[t];return null==e?0:e.frames.length},e.getAnimation=function(t){return this._data[t]},e.getFrame=function(t){var e;return this._frames&&(e=this._frames[t])?e:null},e.getFrameBounds=function(t,e){void 0===e&&(e=new x);var i=this.getFrame(t);return i?e.setValues(-i.regX,-i.regY,i.rect.width,i.rect.height):null},e.toString=function(){return"["+this.constructor.name+"]"},e.clone=function(){throw"SpriteSheet cannot be cloned."},e._parseData=function(t){var n=this;if(null!=t){if(this.framerate=t.framerate||0,t.images){var e=function(){if(s){if(a>=r.length)return"break";o=r[a++]}else{if((a=r.next()).done)return"break";o=a.value}var t=o,e=n._images=[],i=void 0;"string"==typeof t&&(i=t,(t=document.createElement("img")).src=i),e.push(t),t.getContext||t.naturalWidth||(n._loadCount++,n.complete=!1,t.onload=function(){return n._handleImageLoad(i)},t.onerror=function(){return n._handleImageError(i)})},r=t.images,s=Array.isArray(r),a=0;for(r=s?r:r[Symbol.iterator]();;){var o;if("break"===e())break}}if(null!=t.frames)if(Array.isArray(t.frames)){this._frames=[];var i=t.frames,h=Array.isArray(i),u=0;for(i=h?i:i[Symbol.iterator]();;){var l;if(h){if(u>=i.length)break;l=i[u++]}else{if((u=i.next()).done)break;l=u.value}var c=l;this._frames.push({image:this._images[c[4]?c[4]:0],rect:new x(c[0],c[1],c[2],c[3]),regX:c[5]||0,regY:c[6]||0})}}else{var d=t.frames;this._frameWidth=d.width,this._frameHeight=d.height,this._regX=d.regX||0,this._regY=d.regY||0,this._spacing=d.spacing||0,this._margin=d.margin||0,this._numFrames=d.count,0===this._loadCount&&this._calculateFrames()}if(this._animations=[],null!=t.animations){this._data={};var f=t.animations;for(var p in f){var _={name:p},v=f[p],g=void 0;if("number"==typeof v)g=_.frames=[v];else if(Array.isArray(v))if(1===v.length)_.frames=[v[0]];else{_.speed=v[3],_.next=v[2],g=_.frames=[];for(var m=v[0];m<=v[1];m++)g.push(m)}else{_.speed=v.speed,_.next=v.next;var w=v.frames;g=_.frames="number"==typeof w?[w]:w.slice(0)}!0!==_.next&&void 0!==_.next||(_.next=p),(!1===_.next||g.length<2&&_.next===p)&&(_.next=null),_.speed||(_.speed=1),this._animations.push(p),this._data[p]=_}}}},e._handleImageLoad=function(t){0==--this._loadCount&&(this._calculateFrames(),this.complete=!0,this.dispatchEvent("complete"))},e._handleImageError=function(t){var e=new h("error");e.src=t,this.dispatchEvent(e),0==--this._loadCount&&this.dispatchEvent("complete")},e._calculateFrames=function(){if(!this._frames&&0!==this._frameWidth){this._frames=[];var t=this._numFrames||1e5,e=0,i=this._frameWidth,n=this._frameHeight,r=this._spacing,s=this._margin;t:for(var a=0,o=this._images,h=o.length;a<h;a++)for(var u=o[a],l=u.width||u.naturalWidth,c=u.height||u.naturalHeight,d=s;d<=c-s-n;){for(var f=s;f<=l-s-i;){if(t<=e)break t;e++,this._frames.push({image:u,rect:new x(f,d,i,n),regX:this._regX,regY:this._regY}),f+=i+r}d+=n+r}this._numFrames=e}},o(t,[{key:"animations",get:function(){return this._animations.slice()}}]),t}(e),$=function(s){function g(t,e,i){var n;return(n=s.call(this)||this).text=t,n.font=e,n.color=i,n.textAlign="left",n.textBaseline="top",n.maxWidth=null,n.outline=0,n.lineHeight=0,n.lineWidth=null,n}l(g,s);var t=g.prototype;return t.isVisible=function(){var t=this.cacheCanvas||null!=this.text&&""!==this.text;return!!(this.visible&&0<this.alpha&&0!=this.scaleX&&0!=this.scaleY&&t)},t.draw=function(t,e){if(s.prototype.draw.call(this,t,e))return!0;var i=this.color||"#000";return this.outline?(t.strokeStyle=i,t.lineWidth=1*this.outline):t.fillStyle=i,this._drawText(this._prepContext(t)),!0},t.getMeasuredWidth=function(){return this._getMeasuredWidth(this.text)},t.getMeasuredLineHeight=function(){return 1.2*this._getMeasuredWidth("M")},t.getMeasuredHeight=function(){return this._drawText(null,{}).height},t.getBounds=function(){var t=s.prototype.getBounds.call(this);if(t)return t;if(null==this.text||""===this.text)return null;var e=this._drawText(null,{}),i=this.maxWidth&&this.maxWidth<e.width?this.maxWidth:e.width,n=i*g.H_OFFSETS[this.textAlign||"left"],r=(this.lineHeight||this.getMeasuredLineHeight())*g.V_OFFSETS[this.textBaseline||"top"];return this._rectangle.setValues(n,r,i,e.height)},t.getMetrics=function(){var t={lines:[]};return t.lineHeight=this.lineHeight||this.getMeasuredLineHeight(),t.vOffset=t.lineHeight*g.V_OFFSETS[this.textBaseline||"top"],this._drawText(null,t,t.lines)},t.clone=function(){return this._cloneProps(new g(this.text,this.font,this.color))},t.toString=function(){return"["+this.constructor.name+" (text="+(20<this.text.length?this.text.substr(0,17)+"...":this.text)+")]"},t._cloneProps=function(t){return s.prototype._cloneProps.call(this,t),t.textAlign=this.textAlign,t.textBaseline=this.textBaseline,t.maxWidth=this.maxWidth,t.outline=this.outline,t.lineHeight=this.lineHeight,t.lineWidth=this.lineWidth,t},t._prepContext=function(t){return t.font=this.font||"10px sans-serif",t.textAlign=this.textAlign||"left",t.textBaseline=this.textBaseline||"top",t.lineJoin="miter",t.miterLimit=2.5,t},t._drawText=function(t,e,i){var n=!!t;n||((t=g._ctx).save(),this._prepContext(t));var r=this.lineHeight||this.getMeasuredLineHeight(),s=0,a=0,o=String(this.text).split(/(?:\r\n|\r|\n)/),h=Array.isArray(o),u=0;for(o=h?o:o[Symbol.iterator]();;){var l;if(h){if(u>=o.length)break;l=o[u++]}else{if((u=o.next()).done)break;l=u.value}var c=l,d=null;if(null!=this.lineWidth&&(d=t.measureText(c).width)>this.lineWidth){var f=c.split(/(\s)/);c=f[0],d=t.measureText(c).width;for(var p=f.length,_=1;_<p;_+=2){var v=t.measureText(f[_]+f[_+1]).width;d+v>this.lineWidth?(n&&this._drawTextLine(t,c,a*r),i&&i.push(c),s<d&&(s=d),c=f[_+1],d=t.measureText(c).width,a++):(c+=f[_]+f[_+1],d+=v)}}n&&this._drawTextLine(t,c,a*r),i&&i.push(c),e&&null==d&&(d=t.measureText(c).width),s<d&&(s=d),a++}return e&&(e.width=s,e.height=a*r),n||t.restore(),e},t._drawTextLine=function(t,e,i){this.outline?t.strokeText(e,0,i,this.maxWidth||65535):t.fillText(e,0,i,this.maxWidth||65535)},t._getMeasuredWidth=function(t){var e=g._ctx;e.save();var i=this._prepContext(e).measureText(t).width;return e.restore(),i},g}(w);$.H_OFFSETS={start:0,left:0,center:-.5,end:-1,right:-1},$.V_OFFSETS={top:0,hanging:-.01,middle:-.4,alphabetic:-.8,ideographic:-.85,bottom:-1},$._ctx=S().getContext("2d");var tt=function(i){function e(t){var e;return(e=i.call(this)||this).alphaMap=t,e._alphaMap=null,e._mapData=null,e._mapTexture=null,e.FRAG_SHADER_BODY="\n\t\t\tuniform sampler2D uAlphaSampler;\n\n\t\t\tvoid main (void) {\n\t\t\t\tvec4 color = texture2D(uSampler, vRenderCoord);\n\t\t\t\tvec4 alphaMap = texture2D(uAlphaSampler, vTextureCoord);\n\n\t\t\t\t// some image formats can have transparent white rgba(1,1,1, 0) when put on the GPU, this means we need a slight tweak\n\t\t\t\t// using ceil ensure that the colour will be used so long as it exists but pure transparency will be treated black\n\t\t\t\tgl_FragColor = vec4(color.rgb, color.a * (alphaMap.r * ceil(alphaMap.a)));\n\t\t\t}\n\t\t",e}l(e,i);var t=e.prototype;return t.shaderParamSetup=function(t,e,i){this._mapTexture||(this._mapTexture=t.createTexture()),t.activeTexture(t.TEXTURE1),t.bindTexture(t.TEXTURE_2D,this._mapTexture),e.setTextureParams(t),t.texImage2D(t.TEXTURE_2D,0,t.RGBA,t.RGBA,t.UNSIGNED_BYTE,this.alphaMap),t.uniform1i(t.getUniformLocation(i,"uAlphaSampler"),1)},t.clone=function(){var t=new e(this.alphaMap);return t._alphaMap=this._alphaMap,t._mapData=this._mapData,t},t._applyFilter=function(t){if(!this.alphaMap)return!0;if(!this._prepAlphaMap())return!1;for(var e=t.data,i=this._mapData,n=e.length,r=0;r<n;r+=4)e[r+3]=i[r]||0;return!0},t._prepAlphaMap=function(){if(!this.alphaMap)return!1;if(this.alphaMap===this._alphaMap&&this._mapData)return!0;this._mapData=null;var t,e=this._alphaMap=this.alphaMap,i=e;e instanceof HTMLCanvasElement?t=i.getContext("2d"):((i=window.createjs&&createjs.createCanvas?createjs.createCanvas():document.createElement("canvas")).width=e.width,i.height=e.height,(t=i.getContext("2d")).drawImage(e,0,0));try{return this._mapData=t.getImageData(0,0,e.width,e.height).data,!0}catch(t){return!1}},e}(g),et=function(i){function t(t){var e;return(e=i.call(this)||this).mask=t,e.usesContext=!0,e.FRAG_SHADER_BODY="\n\t\t\tuniform sampler2D uAlphaSampler;\n\n\t\t\tvoid main (void) {\n\t\t\t\tvec4 color = texture2D(uSampler, vRenderCoord);\n\t\t\t\tvec4 alphaMap = texture2D(uAlphaSampler, vTextureCoord);\n\n\t\t\t\tgl_FragColor = vec4(color.rgb, color.a * alphaMap.a);\n\t\t\t}\n\t\t",e}l(t,i);var e=t.prototype;return e.applyFilter=function(t,e,i,n,r,s,a,o){return!this.mask||(null==a&&(a=e),null==o&&(o=i),(s=s||t).save(),t==s&&(s.globalCompositeOperation="destination-in",s.drawImage(this.mask,a,o),s.restore(),!0))},e.clone=function(){return new t(this.mask)},e.shaderParamSetup=function(t,e,i){this._mapTexture||(this._mapTexture=t.createTexture()),t.activeTexture(t.TEXTURE1),t.bindTexture(t.TEXTURE_2D,this._mapTexture),e.setTextureParams(t),t.texImage2D(t.TEXTURE_2D,0,t.RGBA,t.RGBA,t.UNSIGNED_BYTE,this.mask),t.uniform1i(t.getUniformLocation(i,"uAlphaSampler"),1)},t}(g),it=function(r){function N(t,e,i){var n;return void 0===t&&(t=0),void 0===e&&(e=0),void 0===i&&(i=1),(n=r.call(this)||this)._blurX=t,n._blurXTable=[],n._lastBlurX=null,n._blurY=e,n._blurYTable=[],n._lastBlurY=null,n._quality=isNaN(i)||i<1?1:i,n._lastQuality=null,n.FRAG_SHADER_TEMPLATE="\n\t\t\tuniform float xWeight[{{blurX}}];\n\t\t\tuniform float yWeight[{{blurY}}];\n\t\t\tuniform vec2 textureOffset;\n\t\t\tvoid main (void) {\n\t\t\t\tvec4 color = vec4(0.0);\n\n\t\t\t\tfloat xAdj = ({{blurX}}.0-1.0)/2.0;\n\t\t\t\tfloat yAdj = ({{blurY}}.0-1.0)/2.0;\n\t\t\t\tvec2 sampleOffset;\n\n\t\t\t\tfor(int i=0; i<{{blurX}}; i++) {\n\t\t\t\t\tfor(int j=0; j<{{blurY}}; j++) {\n\t\t\t\t\t\tsampleOffset = vRenderCoord + (textureOffset * vec2(float(i)-xAdj, float(j)-yAdj));\n\t\t\t\t\t\tcolor += texture2D(uSampler, sampleOffset) * (xWeight[i] * yWeight[j]);\n\t\t\t\t\t}\n\t\t\t\t}\n\n\t\t\t\tgl_FragColor = color.rgba;\n\t\t\t}\n\t\t",n}l(N,r);var t=N.prototype;return t.shaderParamSetup=function(t,e,i){t.uniform1fv(t.getUniformLocation(i,"xWeight"),this._blurXTable),t.uniform1fv(t.getUniformLocation(i,"yWeight"),this._blurYTable),t.uniform2f(t.getUniformLocation(i,"textureOffset"),2/(e._viewportWidth*this._quality),2/(e._viewportHeight*this._quality))},t.getBounds=function(t){var e=0|this.blurX,i=0|this.blurY;if(e<=0&&i<=0)return t;var n=Math.pow(this.quality,.2);return(t||new x).pad(i*n+1,e*n+1,i*n+1,e*n+1)},t.clone=function(){return new N(this.blurX,this.blurY,this.quality)},t._updateShader=function(){var t=this.FRAG_SHADER_TEMPLATE;t=(t=t.replace(/{{blurX}}/g,this._blurXTable.length.toFixed(0))).replace(/{{blurY}}/g,this._blurYTable.length.toFixed(0)),this.FRAG_SHADER_BODY=t},t._getTable=function(t){if(t<=1)return[1];for(var e=[],i=Math.ceil(2*t),n=(i+=i%2?0:1)/2|0,r=-n;r<=n;r++){var s=r/n*4.2;e.push(1/Math.sqrt(2*Math.PI)*Math.pow(Math.E,-Math.pow(s,2)/4))}var a=e.reduce(function(t,e){return t+e},0);return e.map(function(t){return t/a})},t._applyFilter=function(t){var e=this._blurX>>1;if(isNaN(e)||e<0)return!1;var i=this._blurY>>1;if(isNaN(i)||i<0)return!1;if(0===e&&0===i)return!1;var n=this.quality;(isNaN(n)||n<1)&&(n=1),3<(n|=0)&&(n=3),n<1&&(n=1);var r=t.data,s=0,a=0,o=0,h=0,u=0,l=0,c=0,d=0,f=0,p=0,_=0,v=0,g=0,m=0,w=0,x=e+e+1|0,y=i+i+1|0,b=0|t.width,T=0|t.height,E=b-1|0,S=T-1|0,C=e+1|0,M=i+1|0,k={r:0,b:0,g:0,a:0},D=k;for(o=1;o<x;o++)D=D.n={r:0,b:0,g:0,a:0};D.n=k;var L={r:0,b:0,g:0,a:0},A=L;for(o=1;o<y;o++)A=A.n={r:0,b:0,g:0,a:0};A.n=L;for(var I=null,P=0|N.MUL_TABLE[e],R=0|N.SHG_TABLE[e],O=0|N.MUL_TABLE[i],F=0|N.SHG_TABLE[i];0<n--;){c=l=0;var B=P,X=R;for(a=T;-1<--a;){for(d=C*(v=r[0|l]),f=C*(g=r[l+1|0]),p=C*(m=r[l+2|0]),_=C*(w=r[l+3|0]),D=k,o=C;-1<--o;)D.r=v,D.g=g,D.b=m,D.a=w,D=D.n;for(o=1;o<C;o++)h=l+((E<o?E:o)<<2)|0,d+=D.r=r[h],f+=D.g=r[h+1],p+=D.b=r[h+2],_+=D.a=r[h+3],D=D.n;for(I=k,s=0;s<b;s++)r[l++]=d*B>>>X,r[l++]=f*B>>>X,r[l++]=p*B>>>X,r[l++]=_*B>>>X,h=c+((h=s+e+1)<E?h:E)<<2,d-=I.r-(I.r=r[h]),f-=I.g-(I.g=r[h+1]),p-=I.b-(I.b=r[h+2]),_-=I.a-(I.a=r[h+3]),I=I.n;c+=b}for(B=O,X=F,s=0;s<b;s++){for(d=M*(v=r[l=s<<2|0])|0,f=M*(g=r[l+1|0])|0,p=M*(m=r[l+2|0])|0,_=M*(w=r[l+3|0])|0,A=L,o=0;o<M;o++)A.r=v,A.g=g,A.b=m,A.a=w,A=A.n;for(u=b,o=1;o<=i;o++)l=u+s<<2,d+=A.r=r[l],f+=A.g=r[l+1],p+=A.b=r[l+2],_+=A.a=r[l+3],A=A.n,o<S&&(u+=b);if(l=s,I=L,0<n)for(a=0;a<T;a++)r[(h=l<<2)+3]=w=_*B>>>X,0<w?(r[h]=d*B>>>X,r[h+1]=f*B>>>X,r[h+2]=p*B>>>X):r[h]=r[h+1]=r[h+2]=0,h=s+((h=a+M)<S?h:S)*b<<2,d-=I.r-(I.r=r[h]),f-=I.g-(I.g=r[h+1]),p-=I.b-(I.b=r[h+2]),_-=I.a-(I.a=r[h+3]),I=I.n,l+=b;else for(a=0;a<T;a++)r[(h=l<<2)+3]=w=_*B>>>X,0<w?(w=255/w,r[h]=(d*B>>>X)*w,r[h+1]=(f*B>>>X)*w,r[h+2]=(p*B>>>X)*w):r[h]=r[h+1]=r[h+2]=0,h=s+((h=a+M)<S?h:S)*b<<2,d-=I.r-(I.r=r[h]),f-=I.g-(I.g=r[h+1]),p-=I.b-(I.b=r[h+2]),_-=I.a-(I.a=r[h+3]),I=I.n,l+=b}}return!0},o(N,[{key:"blurX",get:function(){return this._blurX},set:function(t){(isNaN(t)||t<0)&&(t=0),this._blurX=t}},{key:"blurY",get:function(){return this._blurY},set:function(t){(isNaN(t)||t<0)&&(t=0),this._blurY=t}},{key:"quality",get:function(){return 0|this._quality},set:function(t){(isNaN(t)||t<0)&&(t=0),this._quality=t}},{key:"_buildShader",get:function(){var t=this._lastBlurX!==this._blurX,e=this._lastBlurY!==this._blurY,i=this._lastQuality!==this._quality;return t||e||i?((t||i)&&(this._blurXTable=this._getTable(this._blurX*this._quality)),(e||i)&&(this._blurYTable=this._getTable(this._blurY*this._quality)),this._updateShader(),this._lastBlurX=this._blurX,this._lastBlurY=this._blurY,void(this._lastQuality=this._quality)):this._compiledShader}},{key:"_builtShader",set:function(t){this._compiledShader=t}}]),N}(g);it.MUL_TABLE=[1,171,205,293,57,373,79,137,241,27,391,357,41,19,283,265,497,469,443,421,25,191,365,349,335,161,155,149,9,278,269,261,505,245,475,231,449,437,213,415,405,395,193,377,369,361,353,345,169,331,325,319,313,307,301,37,145,285,281,69,271,267,263,259,509,501,493,243,479,118,465,459,113,446,55,435,429,423,209,413,51,403,199,393,97,3,379,375,371,367,363,359,355,351,347,43,85,337,333,165,327,323,5,317,157,311,77,305,303,75,297,294,73,289,287,71,141,279,277,275,68,135,67,133,33,262,260,129,511,507,503,499,495,491,61,121,481,477,237,235,467,232,115,457,227,451,7,445,221,439,218,433,215,427,425,211,419,417,207,411,409,203,202,401,399,396,197,49,389,387,385,383,95,189,47,187,93,185,23,183,91,181,45,179,89,177,11,175,87,173,345,343,341,339,337,21,167,83,331,329,327,163,81,323,321,319,159,79,315,313,39,155,309,307,153,305,303,151,75,299,149,37,295,147,73,291,145,289,287,143,285,71,141,281,35,279,139,69,275,137,273,17,271,135,269,267,133,265,33,263,131,261,130,259,129,257,1],it.SHG_TABLE=[0,9,10,11,9,12,10,11,12,9,13,13,10,9,13,13,14,14,14,14,10,13,14,14,14,13,13,13,9,14,14,14,15,14,15,14,15,15,14,15,15,15,14,15,15,15,15,15,14,15,15,15,15,15,15,12,14,15,15,13,15,15,15,15,16,16,16,15,16,14,16,16,14,16,13,16,16,16,15,16,13,16,15,16,14,9,16,16,16,16,16,16,16,16,16,13,14,16,16,15,16,16,10,16,15,16,14,16,16,14,16,16,14,16,16,14,15,16,16,16,14,15,14,15,13,16,16,15,17,17,17,17,17,17,14,15,17,17,16,16,17,16,15,17,16,17,11,17,16,17,16,17,16,17,17,16,17,17,16,17,17,16,16,17,17,17,16,14,17,17,17,17,15,16,14,16,15,16,13,16,15,16,14,16,15,16,12,16,15,16,17,17,17,17,17,13,16,15,17,17,17,16,15,17,17,17,16,15,17,17,14,16,17,17,16,17,17,16,15,17,16,14,17,16,15,17,16,17,17,16,17,15,16,17,14,17,16,15,17,16,17,13,17,16,17,17,16,17,14,17,16,17,16,17,16,17,9];var nt=function(u){function t(t,e,i,n,r,s,a,o){var h;return void 0===t&&(t=1),void 0===e&&(e=1),void 0===i&&(i=1),void 0===n&&(n=1),void 0===r&&(r=0),void 0===s&&(s=0),void 0===a&&(a=0),void 0===o&&(o=0),(h=u.call(this)||this).redMultiplier=t,h.greenMultiplier=e,h.blueMultiplier=i,h.alphaMultiplier=n,h.redOffset=r,h.greenOffset=s,h.blueOffset=a,h.alphaOffset=o,h.FRAG_SHADER_BODY="\n\t\t\tuniform vec4 uColorMultiplier;\n\t\t\tuniform vec4 uColorOffset;\n\n\t\t\tvoid main (void) {\n\t\t\t\tvec4 color = texture2D(uSampler, vRenderCoord);\n\n\t\t\t\tgl_FragColor = (color * uColorMultiplier) + uColorOffset;\n\t\t\t}\n\t\t",h}l(t,u);var e=t.prototype;return e.shaderParamSetup=function(t,e,i){t.uniform4f(t.getUniformLocation(i,"uColorMultiplier"),this.redMultiplier,this.greenMultiplier,this.blueMultiplier,this.alphaMultiplier),t.uniform4f(t.getUniformLocation(i,"uColorOffset"),this.redOffset/255,this.greenOffset/255,this.blueOffset/255,this.alphaOffset/255)},e.clone=function(){return new t(this.redMultiplier,this.greenMultiplier,this.blueMultiplier,this.alphaMultiplier,this.redOffset,this.greenOffset,this.blueOffset,this.alphaOffset)},e._applyFilter=function(t){for(var e=t.data,i=e.length,n=0;n<i;n+=4)e[n]=e[n]*this.redMultiplier+this.redOffset,e[n+1]=e[n+1]*this.greenMultiplier+this.greenOffset,e[n+2]=e[n+2]*this.blueMultiplier+this.blueOffset,e[n+3]=e[n+3]*this.alphaMultiplier+this.alphaOffset;return!0},t}(g),rt=function(){function n(t,e,i,n){this.setColor(t,e,i,n)}var t=n.prototype;return t.setColor=function(t,e,i,n){return this.reset().adjustColor(t,e,i,n)},t.reset=function(){return this.copy(n.IDENTITY_MATRIX)},t.adjustColor=function(t,e,i,n){return this.adjustBrightness(t).adjustContrast(e).adjustSaturation(i).adjustHue(n)},t.adjustBrightness=function(t){return 0===t||isNaN(t)||(t=this._cleanValue(t,255),this._multiplyMatrix([1,0,0,0,t,0,1,0,0,t,0,0,1,0,t,0,0,0,1,0,0,0,0,0,1])),this},t.adjustContrast=function(t){return 0===t||isNaN(t)||(e=(t=this._cleanValue(t,100))<0?127+t/100*127:127*(e=0===(e=t%1)?n.DELTA_INDEX[t]:n.DELTA_INDEX[t<<0]*(1-e)+n.DELTA_INDEX[1+(t<<0)]*e)+127,this._multiplyMatrix([e/127,0,0,0,.5*(127-e),0,e/127,0,0,.5*(127-e),0,0,e/127,0,.5*(127-e),0,0,0,1,0,0,0,0,0,1])),this;var e},t.adjustSaturation=function(t){if(0===t||isNaN(t))return this;var e=1+(0<(t=this._cleanValue(t,100))?3*t/100:t/100);return this._multiplyMatrix([.3086*(1-e)+e,.6094*(1-e),.082*(1-e),0,0,.3086*(1-e),.6094*(1-e)+e,.082*(1-e),0,0,.3086*(1-e),.6094*(1-e),.082*(1-e)+e,0,0,0,0,0,1,0,0,0,0,0,1]),this},t.adjustHue=function(t){if(0===t||isNaN(t))return this;t=this._cleanValue(t,180)/180*Math.PI;var e=Math.cos(t),i=Math.sin(t),n=.213,r=.715,s=.072;return this._multiplyMatrix([n+.787*e+i*-n,r+e*-r+i*-r,s+e*-s+.928*i,0,0,n+e*-n+.143*i,r+e*(1-r)+.14*i,s+e*-s+-.283*i,0,0,n+e*-n+-.787*i,r+e*-r+i*r,s+.928*e+i*s,0,0,0,0,0,1,0,0,0,0,0,1]),this},t.concat=function(t){return(t=this._fixMatrix(t)).length!=n.LENGTH||this._multiplyMatrix(t),this},t.clone=function(){return(new n).copy(this)},t.toArray=function(){for(var t=[],e=n.LENGTH,i=0;i<e;i++)t[i]=this[i];return t},t.copy=function(t){for(var e=n.LENGTH,i=0;i<e;i++)this[i]=t[i];return this},t.toString=function(){return"["+this.constructor.name+"]"},t._multiplyMatrix=function(t){for(var e=[],i=0;i<5;i++){for(var n=0;n<5;n++)e[n]=this[n+5*i];for(var r=0;r<5;r++){for(var s=0,a=0;a<5;a++)s+=t[r+5*a]*e[a];this[r+5*i]=s}}},t._cleanValue=function(t,e){return Math.min(e,Math.max(-e,t))},t._fixMatrix=function(t){return t instanceof n&&(t=t.toArray()),t.length<n.LENGTH?t=t.slice(0,t.length).concat(n.IDENTITY_MATRIX.slice(t.length,n.LENGTH)):t.length>n.LENGTH&&(t=t.slice(0,n.LENGTH)),t},n}();rt.DELTA_INDEX=Object.freeze([0,.01,.02,.04,.05,.06,.07,.08,.1,.11,.12,.14,.15,.16,.17,.18,.2,.21,.22,.24,.25,.27,.28,.3,.32,.34,.36,.38,.4,.42,.44,.46,.48,.5,.53,.56,.59,.62,.65,.68,.71,.74,.77,.8,.83,.86,.89,.92,.95,.98,1,1.06,1.12,1.18,1.24,1.3,1.36,1.42,1.48,1.54,1.6,1.66,1.72,1.78,1.84,1.9,1.96,2,2.12,2.25,2.37,2.5,2.62,2.75,2.87,3,3.2,3.4,3.6,3.8,4,4.3,4.7,4.9,5,5.5,6,6.5,6.8,7,7.3,7.5,7.8,8,8.4,8.7,9,9.4,9.6,9.8,10]),rt.IDENTITY_MATRIX=Object.freeze([1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,1]),rt.LENGTH=25;var st=function(i){function t(t){var e;return(e=i.call(this)||this).matrix=t,e.FRAG_SHADER_BODY="\n\t\t\tuniform mat4 uColorMatrix;\n\t\t\tuniform vec4 uColorMatrixOffset;\n\n\t\t\tvoid main (void) {\n\t\t\t\tvec4 color = texture2D(uSampler, vRenderCoord);\n\n\t\t\t\tmat4 m = uColorMatrix;\n\t\t\t\tvec4 newColor = vec4(0,0,0,0);\n\t\t\t\tnewColor.r = color.r*m[0][0] + color.g*m[0][1] + color.b*m[0][2] + color.a*m[0][3];\n\t\t\t\tnewColor.g = color.r*m[1][0] + color.g*m[1][1] + color.b*m[1][2] + color.a*m[1][3];\n\t\t\t\tnewColor.b = color.r*m[2][0] + color.g*m[2][1] + color.b*m[2][2] + color.a*m[2][3];\n\t\t\t\tnewColor.a = color.r*m[3][0] + color.g*m[3][1] + color.b*m[3][2] + color.a*m[3][3];\n\n\t\t\t\tgl_FragColor = newColor + uColorMatrixOffset;\n\t\t\t}\n\t\t",e}l(t,i);var e=t.prototype;return e.shaderParamSetup=function(t,e,i){var n=this.matrix,r=new Float32Array([n[0],n[1],n[2],n[3],n[5],n[6],n[7],n[8],n[10],n[11],n[12],n[13],n[15],n[16],n[17],n[18]]);t.uniformMatrix4fv(t.getUniformLocation(i,"uColorMatrix"),!1,r),t.uniform4f(t.getUniformLocation(i,"uColorMatrixOffset"),n[4]/255,n[9]/255,n[14]/255,n[19]/255)},e.clone=function(){return new t(this.matrix)},e._applyFilter=function(t){for(var e,i,n,r,s=t.data,a=s.length,o=this.matrix,h=o[0],u=o[1],l=o[2],c=o[3],d=o[4],f=o[5],p=o[6],_=o[7],v=o[8],g=o[9],m=o[10],w=o[11],x=o[12],y=o[13],b=o[14],T=o[15],E=o[16],S=o[17],C=o[18],M=o[19],k=0;k<a;k+=4)e=s[k],i=s[k+1],n=s[k+2],r=s[k+3],s[k]=e*h+i*u+n*l+r*c+d,s[k+1]=e*f+i*p+n*_+r*v+g,s[k+2]=e*m+i*w+n*x+r*y+b,s[k+3]=e*T+i*E+n*S+r*C+M;return!0},t}(g),at=function(){function t(t,e,i,n,r,s,a){void 0===e&&(e="out"),void 0===i&&(i="over"),void 0===n&&(n="down"),void 0===r&&(r=!1),t.addEventListener&&(this.target=t,this.overLabel=i,this.outLabel=e,this.downLabel=null==n,this.play=r,this._isPressed=!1,this._isOver=!1,this._enabled=!1,t.mouseChildren=!1,this.enabled=!0,this.handleEvent({}),s&&(a&&(s.actionsEnabled=!1,s.gotoAndStop&&s.gotoAndStop(a)),t.hitArea=s))}var e=t.prototype;return e.toString=function(){return"["+this.constructor.name+"]"},e.handleEvent=function(t){var e,i=this.target,n=t.type;e="mousedown"===n?(this._isPressed=!0,this.downLabel):"pressup"===n?(this._isPressed=!1,this._isOver?this.overLabel:this.outLabel):"rollover"===n?(this._isOver=!0,this._isPressed?this.downLabel:this.overLabel):(this._isOver=!1,this._isPressed?this.overLabel:this.outLabel),this.play?i.gotoAndPlay&&i.gotoAndPlay(e):i.gotoAndStop&&i.gotoAndStop(e)},e._reset=function(){var t=this.paused;this.__reset(),this.paused=t},o(t,[{key:"enabled",get:function(){return this._enabled},set:function(t){if(t!==this._enabled){var e=this.target;(this._enabled=t)?(e.cursor="pointer",e.addEventListener("rollover",this),e.addEventListener("rollout",this),e.addEventListener("mousedown",this),e.addEventListener("pressup",this),e._reset&&(e.__reset=e._reset,e._reset=this._reset)):(e.cursor=null,e.removeEventListener("rollover",this),e.removeEventListener("rollout",this),e.removeEventListener("mousedown",this),e.removeEventListener("pressup",this),e.__reset&&(e._reset=e.__reset,delete e.__reset))}}}]),t}(),ot={isSupported:function(){return!!("ontouchstart"in window||window.MSPointerEvent&&0<window.navigator.msMaxTouchPoints||window.PointerEvent&&0<window.navigator.maxTouchPoints)},enable:function(t,e,i){return void 0===e&&(e=!1),void 0===i&&(i=!1),!!(t&&t.canvas&&this.isSupported())&&(t.__touch||(t.__touch={pointers:{},multitouch:!e,preventDefault:!i,count:0},"ontouchstart"in window?this._IOS_enable(t):(window.PointerEvent||window.MSPointerEvent)&&this._IE_enable(t)),!0)},disable:function(t){t&&("ontouchstart"in window?this._IOS_disable(t):(window.PointerEvent||window.MSPointerEvent)&&this._IE_disable(t),delete t.__touch)},_IOS_enable:function(e){var i=this,t=e.canvas,n=e.__touch.f=function(t){return i._IOS_handleEvent(e,t)};t.addEventListener("touchstart",n,!1),t.addEventListener("touchmove",n,!1),t.addEventListener("touchend",n,!1),t.addEventListener("touchcancel",n,!1)},_IOS_disable:function(t){var e=t.canvas;if(e){var i=t.__touch.f;e.removeEventListener("touchstart",i,!1),e.removeEventListener("touchmove",i,!1),e.removeEventListener("touchend",i,!1),e.removeEventListener("touchcancel",i,!1)}},_IOS_handleEvent:function(t,e){if(t){t.__touch.preventDefault&&e.preventDefault&&e.preventDefault();var i=e.changedTouches,n=e.type,r=(i.length,i),s=Array.isArray(r),a=0;for(r=s?r:r[Symbol.iterator]();;){var o;if(s){if(a>=r.length)break;o=r[a++]}else{if((a=r.next()).done)break;o=a.value}var h=o,u=h.identifier;h.target==t.canvas&&("touchstart"===n?this._handleStart(t,u,e,h.pageX,h.pageY):"touchmove"===n?this._handleMove(t,u,e,h.pageX,h.pageY):"touchend"!==n&&"touchcancel"!==n||this._handleEnd(t,u,e))}}},_IE_enable:function(e){var i=this,t=e.canvas,n=e.__touch.f=function(t){return i._IE_handleEvent(e,t)};void 0===window.PointerEvent?(t.addEventListener("MSPointerDown",n,!1),window.addEventListener("MSPointerMove",n,!1),window.addEventListener("MSPointerUp",n,!1),window.addEventListener("MSPointerCancel",n,!1),e.__touch.preventDefault&&(t.style.msTouchAction="none")):(t.addEventListener("pointerdown",n,!1),window.addEventListener("pointermove",n,!1),window.addEventListener("pointerup",n,!1),window.addEventListener("pointercancel",n,!1),e.__touch.preventDefault&&(t.style.touchAction="none")),e.__touch.activeIDs={}},_IE_disable:function(t){var e=t.__touch.f;void 0===window.PointerEvent?(window.removeEventListener("MSPointerMove",e,!1),window.removeEventListener("MSPointerUp",e,!1),window.removeEventListener("MSPointerCancel",e,!1),t.canvas&&t.canvas.removeEventListener("MSPointerDown",e,!1)):(window.removeEventListener("pointermove",e,!1),window.removeEventListener("pointerup",e,!1),window.removeEventListener("pointercancel",e,!1),t.canvas&&t.canvas.removeEventListener("pointerdown",e,!1))},_IE_handleEvent:function(t,e){if(t){t.__touch.preventDefault&&e.preventDefault&&e.preventDefault();var i=e.type,n=e.pointerId,r=t.__touch.activeIDs;if("MSPointerDown"===i||"pointerdown"===i){if(e.srcElement!=t.canvas)return;r[n]=!0,this._handleStart(t,n,e,e.pageX,e.pageY)}else r[n]&&("MSPointerMove"===i||"pointermove"===i?this._handleMove(t,n,e,e.pageX,e.pageY):"MSPointerUp"!==i&&"MSPointerCancel"!==i&&"pointerup"!==i&&"pointercancel"!==i||(delete r[n],this._handleEnd(t,n,e)))}},_handleStart:function(t,e,i,n,r){var s=t.__touch;if(s.multitouch||!s.count){var a=s.pointers;a[e]||(a[e]=!0,s.count++,t._handlePointerDown(e,i,n,r))}},_handleMove:function(t,e,i,n,r){t.__touch.pointers[e]&&t._handlePointerMove(e,i,n,r)},_handleEnd:function(t,e,i){var n=t.__touch,r=n.pointers;r[e]&&(n.count--,t._handlePointerUp(e,i,!0),delete r[e])}},ht=function(i){function b(t){var e;return void 0===t&&(t=0),(e=i.call(this)||this).maxWidth=2048,e.maxHeight=2048,e.spriteSheet=null,e.scale=1,e.padding=1,e.timeSlice=.3,e.progress=-1,e.framerate=t,e._frames=[],e._animations={},e._data=null,e._nextFrameIndex=0,e._index=0,e._timerID=null,e._scale=1,e}l(b,i);var t=b.prototype;return t.addFrame=function(t,e,i,n,r){if(void 0===i&&(i=1),this._data)throw b.ERR_RUNNING;var s=e||t.bounds||t.nominalBounds||t.getBounds&&t.getBounds();return s?this._frames.push({source:t,sourceRect:s,scale:i,funct:n,data:r,index:this._frames.length,height:s.height*i})-1:null},t.addAnimation=function(t,e,i,n){if(this._data)throw b.ERR_RUNNING;this._animations[t]={frames:e,next:i,speed:n}},t.addMovieClip=function(t,e,i,n,r,s){if(void 0===i&&(i=1),this._data)throw b.ERR_RUNNING;var a=t.frameBounds,o=e||t.bounds||t.nominalBounds||t.getBounds&&t.getBounds();if(o||a){for(var h=this._frames.length,u=t.timeline.duration,l=0;l<u;l++){var c=a&&a[l]?a[l]:o;this.addFrame(t,c,i,this._setupMovieClipFrame,{i:l,f:n,d:r})}var d=t.timeline._labels,f=[];for(var p in d)f.push({index:d[p],label:p});if(f.length){f.sort(function(t,e){return t.index-e.index});for(var _=0,v=f.length;_<v;_++){for(var g=f[_].label,m=h+f[_].index,w=h+(_===v-1?u:f[_+1].index),x=[],y=m;y<w;y++)x.push(y);s&&!(g=s(g,t,m,w))||this.addAnimation(g,x,!0)}}}},t.build=function(){if(this._data)throw b.ERR_RUNNING;for(this._startBuild();this._drawNext(););return this._endBuild(),this.spriteSheet},t.buildAsync=function(t){var e=this;if(this._data)throw b.ERR_RUNNING;this.timeSlice=t,this._startBuild(),this._timerID=setTimeout(function(){return e._run()},50-50*Math.max(.01,Math.min(.99,this.timeSlice||.3)))},t.stopAsync=function(){clearTimeout(this._timerID),this._data=null},t.toString=function(){return"["+this.constructor.name+"]"},t._startBuild=function(){var t=this.padding||0;this.progress=0,this.spriteSheet=null,this._index=0,this._scale=this.scale;var e=[];this._data={images:[],frames:e,framerate:this.framerate,animations:this._animations};var i=this._frames.slice();if(i.sort(function(t,e){return t.height<=e.height?-1:1}),i[i.length-1].height+2*t>this.maxHeight)throw b.ERR_DIMENSIONS;for(var n=0,r=0,s=0;i.length;){var a=this._fillRow(i,n,s,e,t);if(a.w>r&&(r=a.w),n+=a.h,!a.h||!i.length){var o=window.createjs&&createjs.createCanvas?createjs.createCanvas():document.createElement("canvas");o.width=this._getSize(r,this.maxWidth),o.height=this._getSize(n,this.maxHeight),this._data.images[s]=o,a.h||(r=n=0,s++)}}},t._setupMovieClipFrame=function(t,e){var i=t.actionsEnabled;t.actionsEnabled=!1,t.gotoAndStop(e.i),t.actionsEnabled=i,e.f&&e.f(t,e.d,e.i)},t._getSize=function(t,e){for(var i=4;Math.pow(2,++i)<t;);return Math.min(e,Math.pow(2,i))},t._fillRow=function(t,e,i,n,r){for(var s=this.maxWidth,a=this.maxHeight-(e+=r),o=r,h=0,u=t.length-1;0<=u;u--){var l=t[u],c=this._scale*l.scale,d=l.sourceRect,f=l.source,p=Math.floor(c*d.x-r),_=Math.floor(c*d.y-r),v=Math.ceil(c*d.height+2*r),g=Math.ceil(c*d.width+2*r);if(s<g)throw b.ERR_DIMENSIONS;a<v||s<o+g||(l.img=i,l.rect=new x(o,e,g,v),h=h||v,t.splice(u,1),n[l.index]=[o,e,g,v,i,Math.round(-p+c*f.regX-r),Math.round(-_+c*f.regY-r)],o+=g)}return{w:o,h:h}},t._endBuild=function(){this.spriteSheet=new Z(this._data),this._data=null,this.progress=1,this.dispatchEvent("complete")},t._run=function(){for(var t=this,e=50*Math.max(.01,Math.min(.99,this.timeSlice||.3)),i=(new Date).getTime()+e,n=!1;i>(new Date).getTime();)if(!this._drawNext()){n=!0;break}n?this._endBuild():this._timerID=setTimeout(function(){return t._run()},50-e);var r=this.progress=this._index/this._frames.length;if(this.hasEventListener("progress")){var s=new h("progress");s.progress=r,this.dispatchEvent(s)}},t._drawNext=function(){var t=this._frames[this._index],e=t.scale*this._scale,i=t.rect,n=t.sourceRect,r=this._data.images[t.img].getContext("2d");return t.funct&&t.funct(t.source,t.data),r.save(),r.beginPath(),r.rect(i.x,i.y,i.width,i.height),r.clip(),r.translate(Math.ceil(i.x-n.x*e),Math.ceil(i.y-n.y*e)),r.scale(e,e),t.source.draw(r),r.restore(),++this._index<this._frames.length},b}(e);ht.ERR_DIMENSIONS="frame dimensions exceed max spritesheet dimensions",ht.ERR_RUNNING="a build is already running";var ut={_workingCanvas:S(),get _workingContext(){return this._workingCanvas.getContext("2d")},extractFrame:function(t,e){isNaN(e)&&(e=t.getAnimation(e).frames[0]);var i=t.getFrame(e);if(!i)return null;var n=i.rect,r=this._workingCanvas;r.width=n.width,r.height=n.height,this._workingContext.drawImage(i.image,n.x,n.y,n.width,n.height,0,0,n.width,n.height);var s=document.createElement("img");return s.src=r.toDataURL("image/png"),s},_flip:function(t,e,i,n){for(var r=t._images,s=this._workingCanvas,a=this._workingContext,o=r.length/e,h=0;h<o;h++){var u=r[h];u.__tmp=h,a.setTransform(1,0,0,1,0,0),a.clearRect(0,0,s.width+1,s.height+1),s.width=u.width,s.height=u.height,a.setTransform(i?-1:1,0,0,n?-1:1,i?u.width:0,n?u.height:0),a.drawImage(u,0,0);var l=document.createElement("img");l.src=s.toDataURL("image/png"),l.width=u.width||u.naturalWidth,l.height=u.height||u.naturalHeight,r.push(l)}for(var c=t._frames,d=c.length/e,f=0;f<d;f++){var p=c[f],_=p.rect.clone(),v=r[p.image.__tmp+o*e],g={image:v,rect:_,regX:p.regX,regY:p.regY};i&&(_.x=(v.width||v.naturalWidth)-_.x-_.width,g.regX=_.width-p.regX),n&&(_.y=(v.height||v.naturalHeight)-_.y-_.height,g.regY=_.height-p.regY),c.push(g)}for(var m="_"+(i?"h":"")+(n?"v":""),w=t._animations,x=t._data,y=w.length/e,b=0;b<y;b++){var T=w[b],E=x[T],S={name:T+m,speed:E.speed,next:E.next,frames:[]};E.next&&(S.next+=m);for(var C=E.frames,M=0,k=C.length;M<k;M++)S.frames.push(C[M]+d*e);x[S.name]=S,w.push(S.name)}}},lt=function(i){function c(t){var e;return(e=i.call(this)||this)._stage=t,e}l(c,i),c.dispProps=function(t,e){void 0===e&&(e="");var i="\tP: "+t.x.toFixed(2)+"x"+t.y.toFixed(2)+"\t",n="\tR: "+t.regX.toFixed(2)+"x"+t.regY.toFixed(2)+"\t";c._log(e,t.toString()+"\t",i,n)},c._log=function(){var t,e;c.alternateOutput?(t=c.alternateOutput).log.apply(t,arguments):(e=console).log.apply(e,arguments)};var t=c.prototype;return t.log=function(t){t||(t=this._stage),c._log("Batches Per Draw: "+(t._batchID/t._drawID).toFixed(4)),this.logContextInfo(t._webGLContext),this.logDepth(t.children,""),this.logTextureFill(t)},t.toggleGPUDraw=function(t,e){t||(t=this._stage),void 0===e&&(e=!!t._drawBuffers_),e&&t._drawBuffers_?(t._drawBuffers=t._drawBuffers_,t._drawBuffers_=void 0):(t._drawBuffers_=t._drawBuffers,t._drawBuffers=function(t){this.vocalDebug&&c._log("BlankDraw["+this._drawID+":"+this._batchID+"] : "+this.batchReason)})},t.logDepth=function(t,e,i){void 0===e&&(e=""),void 0===i&&(i=c._log),t||(t=this._stage.children);for(var n=t.length,r=0;r<n;r++){var s=t[r];i(e+"-",s),s.children&&s.children.length&&this.logDepth(s.children,"|"+e,i)}},t.logContextInfo=function(t){t||(t=this._stage._webGLContext);var e="\n\t\t\t== LOG:\n\n\t\t\tMax textures per draw: "+t.getParameter(t.MAX_TEXTURE_IMAGE_UNITS)+"\n\n\t\t\tMax textures active: "+t.getParameter(t.MAX_COMBINED_TEXTURE_IMAGE_UNITS)+"\n\n\t\t\t\n\n\t\t\tMax texture size: "+t.getParameter(t.MAX_TEXTURE_SIZE)/2+"\n\n\t\t\tMax cache size: "+t.getParameter(t.MAX_RENDERBUFFER_SIZE)/2+"\n\n\t\t\t\n\n\t\t\tMax attributes per vertex: "+t.getParameter(t.MAX_VERTEX_ATTRIBS)+"\n\n\t\t\tWebGL Version string: "+t.getParameter(t.VERSION)+"\n\n\t\t\t======\n\t\t";c._log(e)},t.logTextureFill=function(i){i||(i=this._stage);var t=i._textureDictionary,e=i._batchTextureCount;c._log(textureMax+": "+e);var n=[];for(var r in t){r.replace(window.location.origin,"");var s=t[r],a=!!s._lastActiveIndex&&s._lastActiveIndex===s._activeIndex;n.push({src:src,element:s,shifted:a}),s._lastActiveIndex=s._activeIndex}n.sort(function(t,e){return t.element._drawID===i._drawID?1:t.element._drawID<e.element._drawID?-1:0});for(var o=n.length,h=0;h<o;h++){var u=n[h],l=u.element._drawID===i._drawID;c._log("["+u.src+"] "+(l?"ACTIVE":"stale")+" "+(u.shifted?"steady":"DRIFT"),u.element)}},c}(e);lt.alternateOutput=null,t.Event=h,t.EventDispatcher=e,t.Ticker=s,t.StageGL=u,t.Stage=E,t.Container=b,t.DisplayObject=w,t.Bitmap=M,t.BitmapText=D,t.DOMElement=L,t.Graphics=A,t.MovieClip=J,t.Shadow=c,t.Shape=K,t.Sprite=k,t.SpriteSheet=Z,t.Text=$,t.MouseEvent=T,t.AlphaMapFilter=tt,t.AlphaMaskFilter=et,t.BitmapCache=m,t.BlurFilter=it,t.ColorFilter=nt,t.ColorMatrix=rt,t.ColorMatrixFilter=st,t.Filter=g,t.DisplayProps=v,t.Matrix2D=_,t.Point=p,t.Rectangle=x,t.ButtonHelper=at,t.Touch=ot,t.SpriteSheetBuilder=ht,t.SpriteSheetUtils=ut,t.uid=f,t.createCanvas=S,t.WebGLInspector=lt,(t.versions=t.versions||{}).easeljs="2.0.0-beta.4"}(this.createjs=this.createjs||{},this.createjs);
